import sys
import java
#sys.path.append('./multispectral/Lib')
#sys.path.append('./multispectral/Lib/file')
from visad.python.JPythonMethods import *
import visad
import graph
import subs
import jarray
from visad import RealType, RealTupleType, FunctionType, FlatField, Gridded1DSet, Gridded2DSet, GridCoordinateSystem, Data
from javax.swing import *
from java.awt import BorderLayout,GridLayout,FlowLayout,Color,Cursor, Toolkit, Dimension, Font
from java.awt.event import ActionEvent
from javax.swing.border import LineBorder, CompoundBorder, EmptyBorder
from visad import Real, RealTuple, FieldImpl, Tuple, TupleType, TextType, Text, TextControl, DataReferenceImpl
from visad.bom import HydraImageRendererJ3D
from java.lang import Double, String, Float, Runtime
from visad import DisplayListener, DisplayEvent, DisplayRealType, DisplayTupleType, ScalarMap, ConstantMap, Display
from visad.data.mcidas import BaseMapAdapter
from visad.java3d import DirectManipulationRendererJ3D, MouseBehaviorJ3D

#-- linear combination of channels
import channelLinearCombine
from channelLinearCombine import ChannelLinearCombo
import transect
from histostretch import dragHistLocation
from util import Helper, ScalarMapSyncher, Syncher, ActionSync
import rgb_combine
from rgb_combine import RGB_Combine

false = 0
true  = 1

toolkit = Toolkit.getDefaultToolkit()

screen_size = toolkit.getScreenSize()
runtime = Runtime.getRuntime()
import hydra_properties
import hydra_globals
from hydra_globals import geoPointRef_s
import lockCell
from hydra_globals import getImageRenderer
from hydra_globals import hydra_path
from hframe import HFrame
import ColorScaleSelect



class acViewer:
  # changeImage is called when the user moves the spectra marker.
  # This method is used to change the image that is shown
  # you pass in a 'value' which is a Wavenumber, and it
  # computes the wavenumber index, and calls 'getImage()' 

  def radToBT(self, val):
    return self.ad.radianceToBrightnessTemp([val], self.channelIndex)[0]

  def BTtoRad(self, val):
    return self.ad.brightnessTempToRadiance([val], self.selChannel)[0]

  def changeImage(self,observationChannel,dum_value):
    if observationChannel >= self.observationChannelsInstrumentMX[0] and observationChannel <= self.observationChannelsInstrumentMX[1]:  # in case these are missing
      # get the range and make a new line...
      self.selChannel = observationChannel
      spectralIndex   = self.ad.observationDomain.valueToIndex([[observationChannel],])[0]
      self.channelIndex = spectralIndex
      channelText = None
      if (self.last_spectralIndex != spectralIndex):
        self.last_spectralIndex = spectralIndex

        updown = self.maps2[1].getRange() # get the range of radiance values
        updown[0] = self.y0
        updown[1] = self.y1
        y_scalar = self.maps2[1].getScalar()
        x = self.ad.observationDomain.indexToValue([spectralIndex])
       
        self.rgbMap.resetAutoScale()
        self.d.reAutoScale()
        self.frame.setCursor(3)
        syncher = ScalarMapSyncher(self.rgbMap)
        self.ad.getSameImageSegment(spectralIndex)
        self.frame.setCursor(0)
    
        syncher.waitForEvent()
        #set the channel string for the middle panel
        channelText = '%-6.2f' % (self.ad.observationChannels[spectralIndex])
        self.instrumentString1.setText(channelText)

        valid_range = self.ad.getObsValidRange()
        

        if self.ad.instrumentName == "MODIS":
          self.bandNumberText.setSelectedIndex(self.ad.fileIndexes[spectralIndex])
          if self.ad.fileIndexes[spectralIndex] <= 21 and self.colorMenu.current == ColorScaleSelect.igray_cmd:
            self.colorMenu.scaleSelect(ActionEvent(self,ActionEvent.ACTION_PERFORMED,ColorScaleSelect.gray_cmd))
          elif self.ad.fileIndexes[spectralIndex] > 21 and self.colorMenu.current == ColorScaleSelect.gray_cmd:
            self.colorMenu.scaleSelect(ActionEvent(self,ActionEvent.ACTION_PERFORMED,ColorScaleSelect.igray_cmd))

          if self.ad.fileIndexes[spectralIndex] <= 21:
            updown = valid_range[0]
            y_scalar = self.maps2[1].getScalar()
          else:
            updown = valid_range[1]
            y_scalar = self.maps2[2].getScalar()
          channelText = self.bandNumberText.getSelectedItem()

        if self.ad.instrumentName == "AVHRR":
          self.bandNumberText.setSelectedIndex(spectralIndex)
          if spectralIndex <= 1 and self.colorMenu.current == ColorScaleSelect.igray_cmd:
            self.colorMenu.scaleSelect(ActionEvent(self,ActionEvent.ACTION_PERFORMED,ColorScaleSelect.gray_cmd))
          elif spectralIndex > 2 and self.colorMenu.current == ColorScaleSelect.gray_cmd:
            self.colorMenu.scaleSelect(ActionEvent(self,ActionEvent.ACTION_PERFORMED,ColorScaleSelect.igray_cmd))

          if spectralIndex <= 1:
            updown = valid_range[0]
            y_scalar = self.maps2[1].getScalar()
          else:
            updown = valid_range[1]
            y_scalar = self.maps2[2].getScalar()
          channelText = self.bandNumberText.getSelectedItem()

            
        if self.ad.instrumentName == "MSG" or self.ad.instrumentName == "MSG_local":
          self.bandNumberText.setSelectedIndex(self.ad.fileIndexes[spectralIndex])
          if self.ad.fileIndexes[spectralIndex] <= 2 and self.colorMenu.current == ColorScaleSelect.igray_cmd:
            self.colorMenu.scaleSelect(ActionEvent(self,ActionEvent.ACTION_PERFORMED,ColorScaleSelect.gray_cmd))
            updown = valid_range[0]
          elif self.ad.fileIndexes[spectralIndex] > 2 and self.colorMenu.current == ColorScaleSelect.gray_cmd:
            self.colorMenu.scaleSelect(ActionEvent(self,ActionEvent.ACTION_PERFORMED,ColorScaleSelect.igray_cmd))
            updown = valid_range[1]

          if self.ad.fileIndexes[spectralIndex] <= 2:
            updown = valid_range[0]
            y_scalar = self.maps2[1].getScalar()
          else:
            updown = valid_range[1]
            y_scalar = self.maps2[2].getScalar()
          channelText = self.bandNumberText.getSelectedItem()

        if self.ad.instrumentName == "GOES-E" or self.ad.instrumentName == "GOES-W":
          self.bandNumberText.setSelectedIndex(self.ad.fileIndexes[spectralIndex])
          if self.ad.fileIndexes[spectralIndex] <= 0 and self.colorMenu.current == ColorScaleSelect.igray_cmd:
            self.colorMenu.scaleSelect(ActionEvent(self,ActionEvent.ACTION_PERFORMED,ColorScaleSelect.gray_cmd))
            updown = valid_range[0]
          elif self.ad.fileIndexes[spectralIndex] > 0 and self.colorMenu.current == ColorScaleSelect.gray_cmd:
            self.colorMenu.scaleSelect(ActionEvent(self,ActionEvent.ACTION_PERFORMED,ColorScaleSelect.igray_cmd))
            updown = valid_range[1]

          if self.ad.fileIndexes[spectralIndex] <= 0:
            updown = valid_range[0]
            y_scalar = self.maps2[1].getScalar()
          else:
            updown = valid_range[1]
            y_scalar = self.maps2[2].getScalar()
          channelText = self.bandNumberText.getSelectedItem()

        pts = subs.makeLine(
              (self.observationChannelsInstrument,y_scalar) , ((x[0][0],x[0][0]),(updown[0],updown[1])) )
        self.lref.setData(pts)

        self.updateImageText()
        
        ll = self.ad.cs.toReference([[self.currentLine],[self.currentElem]])
        lat = ll[0][0]
        lon = ll[1][0]
        val = self.ad.getImageValue(lat, lon).getValue()
        strg='Lat = %-7.3f  Lon = %-8.3f     Val = %-6.2f  ' % (lat, lon, val)
        strg = strg+self.ad.imageRangeUnit.toString()
        #self.latLonStringInstrument.setText(strg)
        self.updateLocationLabel(lat,lon)


  def imageToSubset(self, line, elem):
    imageDomain = self.ad.imageField.getDomainSet()
    lens = imageDomain.getLengths()
    dim  = len(lens)
    idx  = imageDomain.valueToIndex([[line], [elem]])[0]
    grid = []
    k = idx;
    for j in xrange(dim-1):
      grid.append( k % lens[j]);
      k = k / lens[j];
    grid.append(k)

    numLine = int(grid[0])
    numElem = int(grid[1])
    return [numLine, numElem]

  def displayToSubset(self, x, y):
    scale = jarray.zeros(2, 'f')
    offset = jarray.zeros(2, 'f')
   
    self.ds_cs.getScaleOffset(scale, offset)

    x = x*scale[0] + offset[0]
    y = y*scale[1] + offset[1]

    return self.imageToSubset(x, y)

  def updateGeoPoint(self, lon, lat, idx, noTrigger=false):
    if noTrigger == true:
      self.geoPtCell_s[idx].setNoTrigger(true)
    geoPointRef_s[idx].setData(RealTuple(RealTupleType.SpatialEarth2DTuple, [lon, lat]))
    
  def updateSpectra(self, lonlatTuple):
    if lonlatTuple != None:
      comps = lonlatTuple.getComponents()
      x = comps[0].getValue()
      y = comps[1].getValue()
      if self.ds_cs != None:
        ll = self.ds_cs.toReference([[x],[y],[0]])
        self.changeSpectra(ll[0][0], ll[1][0])
      else:
        self.changeSpectra(x,y)

  def updateRefSpectra(self, lonlatTuple):
    if self.refSpecToggleButton.isSelected() == false:
      return

    comps = lonlatTuple.getComponents()
    lon = comps[0].getValue()
    lat = comps[1].getValue()
    xy = self.ad.cs.fromReference([[lat,],[lon,]])
    numLine = xy[0][0]
    numElem = xy[1][0]

    imageDomain = self.ad.imageField.getDomainSet()
    lens = imageDomain.getLengths()
    dim  = len(lens)
    idx  = imageDomain.valueToIndex([[numLine], [numElem]])[0]
    grid = []

    k = idx;
    for j in xrange(dim-1):
      grid.append( k % lens[j])
      k = k / lens[j]
      grid.append(k)

    numLine = int(grid[0])
    numElem = int(grid[1])

    self.refSpecDispListnr.currentLine = numLine
    self.refSpecDispListnr.currentElem = numElem
    self.refSpectrumRef.setData(self.ad.getObservations(numLine,numElem,true))
    self.updateSpecDiff()
    altVal = (self.altitudeMap.inverseScaleValues([0.2]))[0]
    self.refMarkerRef.setData(RealTuple(RealTupleType(self.obsLatitudeInstrument, self.obsLongitudeInstrument, RealType.Altitude), [lat, lon, altVal]))
    self.refSpecDispListnr.last = self.refMarkerRef.getData()

    self.updateLocationLabel(lat,lon)

  def doChangeSpectra(self,lon,lat):
    self.shapes.moveShape(self.shapeMarkerIndex,(lon,lat))
                                                                                                                               
    if self.ds_cs != None:
      ll = self.ds_cs.fromReference([[lon], [lat], [0]])
      lon = ll[0][0]
      lat = ll[1][0]

    self.updateGeoPoint(lon, lat, 0)


# changeSpectra is called when the user moves the spot around
# on the image, indicating to read a new spectra.
# This method is used to get a Spectra and also move the
# little marker in the image.
  def changeSpectra(self,lon,lat):
    if self.shapes != None:
      self.shapes.moveShape(self.shapeMarkerIndex,(lon,lat))

    if self.ds_cs != None:
      ll = self.ds_cs.fromReference([[lon], [lat], [0]])
      lon = ll[0][0]
      lat = ll[1][0]

    if self.ad.cs != None:
      xy = self.ad.cs.fromReference([[lat,],[lon,]])
      numLine = xy[0][0]
      numElem = xy[1][0]
        
      imageDomain = self.ad.imageField.getDomainSet()
      lens = imageDomain.getLengths()
      dim = len(lens)
      idx = imageDomain.valueToIndex([[numLine], [numElem]])[0]
      grid = []

      k = idx
      for j in xrange(dim-1):
        grid.append( k % lens[j])
        k = k / lens[j]
      grid.append(k)

      try:
        self.currentLine = int(numLine)
        self.currentElem = int(numElem)
      except: #- off image
        return
      numLine = int(grid[0])
      numElem = int(grid[1])
 
    if numLine >= 0 and numLine < self.dimInstrument[0] and numElem >= 0 and numElem < self.dimInstrument[1]:
      self.frame.setCursor(3)
      self.ad.getObservations(numLine,numElem)
      self.frame.setCursor(0)

      self.updateSpecDiff()

      val = self.ad.getImageValue(lat, lon).getValue()
      strg='Lat = %-7.3f  Lon = %-8.3f     Val = %-6.2f  ' % (lat, lon, val)
      strg = strg+self.ad.imageRangeUnit.toString()
      tt = self.ad.getTimeObs(numLine,numElem)
      strgTime = ""
      if tt != None:
        strgTime='Time = %-6.2f [offset (s)]' % (tt)
      strgFOV = ""
      ff = self.ad.getFOVangleObs(numLine,numElem)
      if ff != None:
        strgFOV='FOV angle = %-6.2f [degrees]' % (ff)
    else:
      strg='Lat = %-7.3f  Lon = %-8.3f not in swath' % (lat, lon)
      strgTime='Time not available'
      strgFOV='FOV angle not defined'
 
    #self.latLonStringInstrument.setText(strg)
    self.updateLocationLabel(lat,lon)
    self.timeStringInstrument.setText(strgTime)
    self.FOVangleStringInstrument.setText(strgFOV)

    if self.roamTextRef != None:
      val = self.ad.getImageValue(lat, lon).getValue()
      roamText = Tuple(TupleType([self.obsLatitudeInstrument, self.obsLongitudeInstrument, self.text]), [Real(self.obsLatitudeInstrument, lat), Real(self.obsLongitudeInstrument, lon), Text(self.text, '   %-6.2f' % val)])
      self.roamTextRef.setData(roamText)


  def updateSpecDiff(self):
    if self.spectrumDiffRef != None and self.refSpectrumRef != None:
      if isinstance(self.spectrumRef, DataReferenceImpl):
        d   = self.spectrumRef.getData() - self.refSpectrumRef.getData()
        #mt  = d.getType()
        #nmt = FunctionType(mt.getDomain(), self.specDiffType)
        #nd  = d.changeMathType(nmt)
        #self.spectrumDiffRef.setData(nd)
        self.spectrumDiffRef.setData(d)
      else:
        s0 = self.spectrumRef[0].getData()
        r0 = self.refSpectrumRef.getData().getComponent(0)
        s1 = self.spectrumRef[1].getData()
        r1 = self.refSpectrumRef.getData().getComponent(1)
        vals_0 = s0.getFloats()
        d0 = s0 - r0
        d1 = s1 - r1
        dvals_0 = d0.getFloats()
        dvals_1 = d1.getFloats()
        #- TDR, diff stuff broken anyway (11-12-2007)
        ##d0.setSamples([vals_0[0], dvals_0[1]])
        ##d1.setSamples([vals_0[0], dvals_1[1]])
        mt  = d0.getType()
        nmt = FunctionType(mt.getDomain(), RealTupleType(mt.getRange().getComponent(0), self.specDiffType.getComponent(0)))
        nd0 = d0.changeMathType(nmt)
        nmt = FunctionType(mt.getDomain(), RealTupleType(mt.getRange().getComponent(0), self.specDiffType.getComponent(1)))
        nd1 = d1.changeMathType(nmt)
        self.spectrumDiffRef.setData(Tuple([nd0, nd1]))

    if self.glbSpecToggleButton.isSelected() == true:
      for i in xrange(len(hydra_globals.mcViewer_s)):
        mcv = hydra_globals.mcViewer_s[i]
        if (mcv != self):
          mcv.updateSpecDiff()

     
  def sliderchanged(self,event):
    if self.slider.getValueIsAdjusting(): return
    seg=int(self.slider.getValue())

    if (seg != self.selSegment):
      self.selSegment = seg
      self.frame.setCursor(3)
      self.obs = self.ad.getImageSegment(self.channel,self.selSegment)
      self.frame.setCursor(0)
      self.rgbMap.resetAutoScale()
      self.d.reAutoScale()

      self.d.disableAction()
      self.d.removeReference(self.refToImage)
      self.d.removeMap(self.maps[0])
      self.d.removeMap(self.maps[1])
      self.displayLonType, self.displayLatType, self.displayAltType = self.makeDisplaySpatialRealTypes()
      self.maps[0] = ScalarMap(self.obsLongitudeInstrument, self.displayLonType)
      self.maps[1] = ScalarMap(self.obsLatitudeInstrument, self.displayLatType)
      self.d.addMap(self.maps[0])
      self.d.addMap(self.maps[1])
      self.refToImage = subs.addData('a',self.obs,self.d, constantMaps=[ConstantMap(-0.2, self.displayAltType)], renderer=getImageRenderer())
      self.maps[0].setRange(self.lon_low, self.lon_hi)
      self.maps[1].setRange(self.lat_low, self.lat_hi)
      self.updateImageText()
      self.proj_cntrl.setMatrix(self.init_matrix)
      self.d.enableAction()
  
      dimInstrumentDom=self.obs.getDomainSet()
      self.dimInstrument=dimInstrumentDom.getLengths()
  
      ll0=self.ad.cs.toReference([[0],[0]])
      ll1=self.ad.cs.toReference([[0],[self.dimInstrument[1]-1]])
      ll2=self.ad.cs.toReference([[self.dimInstrument[0]-1],[self.dimInstrument[1]-1]])
      ll3=self.ad.cs.toReference([[self.dimInstrument[0]-1],[0]])
    
      if self.ds_cs != None:
        ll = self.ds_cs.toReference([ [ll0[1][0] ], [ ll0[0][0] ], [0]])
        self.changeSpectra(ll[0][0], ll[1][0])
      else:
        self.changeSpectra(ll0[1][0],ll0[0][0])
      
      strg='Lat = %-6.2f  Lon = %-7.2f' % (ll0[0][0], ll0[1][0])
      #self.latLonStringInstrument.setText(strg)
      self.updateLocationLabel(ll0[0][0], ll0[1][0])
    
      tt = self.ad.getTimeObs(0,0)
      strgTime = ""
      if tt != None:
        strgTime='Time = %-6.2f [offset (s)]' % (tt)
      self.timeStringInstrument.setText(strgTime)
      
      ff = self.ad.getFOVangleObs(0,0)
      strgFOV = ""
      if ff != None:
        strgFOV='FOV angle = %-6.2f [degrees]' % (ff)
      self.FOVangleStringInstrument.setText(strgFOV)

      
  def changeSubset(self, subset):
    self.proj_cntrl.setMatrix(self.init_matrix)

    self.currentSubset = subset
    self.frame.setCursor(3)
    self.obs = self.ad.getImageSegment(self.channelIndex,self.selSegment,subset)

    if self.ext_display != None:
      self.refToImage.setData(self.obs)
      self.frame.setCursor(0)
      return

    self.rgbMap.resetAutoScale()
    self.d.reAutoScale()
    self.d.disableAction()

    self.d.removeReference(self.refToImage)
    if self.refMarkerRef != None:
      self.d.removeReference(self.refMarkerRef)
    self.d.removeMap(self.maps[0])
    self.d.removeMap(self.maps[1])
    self.d.removeMap(self.maps[8])
    self.d.removeMap(self.maps[5])
    if self.currentProj == "Instrument" and (not(self.ad.instrumentName == "MSG" or self.ad.instrumentName == "GOES-E" or self.ad.instrumentName == "GOES-W" or self.ad.instrumentName == "GOES-10")):
      self.d.removeMap(self.imgXmap)
      self.d.removeMap(self.imgYmap)

    self.displayLonType, self.displayLatType, self.displayAltType = self.makeDisplaySpatialRealTypes()
    self.maps[0] = ScalarMap(self.obsLongitudeInstrument, self.displayLonType)
    self.maps[1] = ScalarMap(self.obsLatitudeInstrument, self.displayLatType)
    self.maps[8] = ScalarMap(RealType.Altitude, self.displayAltType)
    self.maps[5] = ScalarMap(self.text, Display.Text)
    self.d.addMap(self.maps[0])
    self.d.addMap(self.maps[1])
    self.d.addMap(self.maps[8])
    self.d.addMap(self.maps[5])
    self.txtCntrl = self.maps[5].getControl()
    self.txtCntrl.setJustification(TextControl.Justification.LEFT)
    self.txtCntrl.setAutoSize(1)
    self.txtCntrl.setFont(Font("sansserif", Font.PLAIN, 14))
    self.ll_grid.resetTextMap()

    ir = getImageRenderer()
    self.refToImage = DataReferenceImpl('image')
    self.refToImage.setData(self.obs)

    if self.currentProj == "Instrument" and (not(self.ad.instrumentName == "MSG" or self.ad.instrumentName == "GOES-E" or self.ad.instrumentName == "GOES-W" or self.ad.instrumentName == "GOES-10")):
      self.imgXmap = ScalarMap(self.obsElementInstrument, Display.XAxis)
      self.imgYmap = ScalarMap(self.obsLineInstrument, Display.YAxis)
      self.d.addMap(self.imgXmap)
      self.d.addMap(self.imgYmap)
      scale = jarray.zeros(2, 'f')
      offst = jarray.zeros(2, 'f')
      rect = self.ds_cs.getScaleOffset(scale, offst)
      self.imgXmap.setRange( (-1.0*scale[0] + offst[0]), (1.0*scale[0] + offst[0]))
      self.imgYmap.setRange( (-1.0*scale[1] + offst[1]), (1.0*scale[1] + offst[1]))
      self.d.addReferences(ir, self.refToImage, [ConstantMap(-0.2, Display.ZAxis)])
    else:
      self.d.addReferences(ir, self.refToImage, [ConstantMap(-0.2, self.displayAltType)])

    self.maps[0].setRange(self.lon_low, self.lon_hi)
    self.maps[1].setRange(self.lat_low, self.lat_hi)
    ##self.refToImage.setData(self.obs)
    #---------------
    self.updateImageText()

    if self.refMarkerRef != None:
      altVal = (self.altitudeMap.inverseScaleValues([0.2]))[0]
      refMark = RealTuple(RealTupleType([self.obsLatitudeInstrument, self.obsLongitudeInstrument, RealType.Altitude]), [Real(self.obsLatitudeInstrument, self.ad.obsMin[0]), Real(self.obsLongitudeInstrument, self.ad.obsMin[1]), Real(RealType.Altitude, altVal)], None)
      self.refMarkerRef = subs.addData('a',refMark,self.d,subs.makeColorMap('red')+[ConstantMap(0.2, self.displayAltType)], renderer=DirectManipulationRendererJ3D())
      self.refSpecDispListnr.refMarkerRef = self.refMarkerRef
      le = self.ad.cs.fromReference([[self.ad.obsMin[0]],[self.ad.obsMin[1]]])
      le = self.imageToSubset(le[0][0], le[1][0])
      self.refSpectrumRef.setData(self.ad.getObservations(le[0], le[1], true))
    
    ##self.proj_cntrl.setMatrix(self.init_matrix)

    dimInstrumentDom=self.obs.getDomainSet()
    self.dimInstrument=dimInstrumentDom.getLengths()

    ll0=self.ad.cs.toReference([[0],[0]])

    if self.ds_cs != None:
      ll = self.ds_cs.toReference([ [ll0[1][0] ], [ ll0[0][0] ], [0]])
      self.changeSpectra(ll[0][0], ll[1][0])
    else:
      self.changeSpectra(ll0[1][0],ll0[0][0])

    strg='Lat = %-6.2f  Lon = %-7.2f' % (ll0[0][0], ll0[1][0])
    #self.latLonStringInstrument.setText(strg)
    self.updateLocationLabel(ll0[0][0], ll0[1][0])

    tt = self.ad.getTimeObs(0,0)
    strgTime = ""
    if tt != None:
      strgTime='Time = %-6.2f [offset (s)]' % (tt)
    self.timeStringInstrument.setText(strgTime)

    ff = self.ad.getFOVangleObs(0,0)
    strgFOV = ""
    if ff != None:
      strgFOV='FOV angle = %-6.2f [degrees]' % (ff)
    self.FOVangleStringInstrument.setText(strgFOV)
    self.frame.setCursor(0)

    self.d.enableAction()
    self.updateDisplay(subset)
    ##self.d.enableAction()
    self.ll_grid.update(self.ds_cs)
    self.imageLabel.disable()
    self.imgLblItem.setSelected(0)

    transect.updateImageRef(self.refToImage, self.ds_cs, self.displayAltType)
    

  def changeProjection(self,event):
    cmd = event.getActionCommand()
    if cmd == 'Lambert Equal Area':
      self.currentProj = cmd
    elif cmd == 'Polar Stereographic':
      self.currentProj = cmd
    elif cmd == 'Instrument':
      self.currentProj = cmd

    self.d.disableAction()
    self.d.removeReference(self.refToImage)
    if self.refMarkerRef != None:
      self.d.removeReference(self.refMarkerRef)
    self.d.removeMap(self.maps[0])
    self.d.removeMap(self.maps[1])
    self.d.removeMap(self.maps[8])
    self.d.removeMap(self.maps[5])
    if self.imgXmap != None and self.imgYmap != None:
      self.d.removeMap(self.imgXmap)
      self.d.removeMap(self.imgYmap)
      self.imgXmap = None
      self.imgYmap = None
    self.displayLonType, self.displayLatType, self.displayAltType = self.makeDisplaySpatialRealTypes()
    self.maps[0] = ScalarMap(self.obsLongitudeInstrument, self.displayLonType)
    self.maps[1] = ScalarMap(self.obsLatitudeInstrument, self.displayLatType)
    self.maps[8] = ScalarMap(RealType.Altitude, self.displayAltType)
    self.maps[5] = ScalarMap(self.text, Display.Text)
    self.d.addMap(self.maps[0])
    self.d.addMap(self.maps[1])
    self.d.addMap(self.maps[8])
    self.d.addMap(self.maps[5])
    self.txtCntrl = self.maps[5].getControl()
    self.txtCntrl.setJustification(TextControl.Justification.LEFT)
    self.txtCntrl.setAutoSize(1)
    self.txtCntrl.setFont(Font("sansserif", Font.PLAIN, 14))
    self.ll_grid.resetTextMap()

    if self.currentProj == "Instrument" and (not(self.ad.instrumentName == "MSG" or self.ad.instrumentName == "GOES-E" or self.ad.instrumentName == "GOES-W" or self.ad.instrumentName == "GOES-10")):
      self.imgXmap = ScalarMap(self.obsElementInstrument, Display.XAxis)
      self.imgYmap = ScalarMap(self.obsLineInstrument, Display.YAxis)
      self.d.addMap(self.imgXmap)
      self.d.addMap(self.imgYmap)
      self.ad.setUnnavigatedImage(true)
      self.obs = self.ad.getUnnavigatedImage()
      scale = jarray.zeros(2, 'f')
      offst = jarray.zeros(2, 'f')
      rect = self.ds_cs.getScaleOffset(scale, offst)
      self.imgXmap.setRange( (-1.0*scale[0] + offst[0]), (1.0*scale[0] + offst[0]))
      self.imgYmap.setRange( (-1.0*scale[1] + offst[1]), (1.0*scale[1] + offst[1]))
      self.refToImage = subs.addData('a',self.obs,self.d, constantMaps=[ConstantMap(-0.2, Display.ZAxis)], renderer=getImageRenderer())
    else:
      self.ad.setUnnavigatedImage(false)
      self.obs = self.ad.getNavigatedImage()
      self.refToImage = subs.addData('a',self.obs,self.d, constantMaps=[ConstantMap(-0.2, self.displayAltType)], renderer=getImageRenderer())
    self.maps[0].setRange(self.lon_low, self.lon_hi)
    self.maps[1].setRange(self.lat_low, self.lat_hi)

    ll = self.ad.cs.toReference([[self.currentLine],[self.currentElem]])
    if self.ds_cs != None:
      ll = self.ds_cs.toReference([ [ll[1][0] ], [ ll[0][0] ], [0]])
    self.shapes.moveShape(self.shapeMarkerIndex,(ll[0][0],ll[1][0]))

    if self.refMarkerRef != None:
      refMark = self.refMarkerRef.getData()
      self.refMarkerRef = subs.addData('a',refMark,self.d,subs.makeColorMap('red')+[ConstantMap(0.2, self.displayAltType)], renderer=DirectManipulationRendererJ3D())
      self.refSpecDispListnr.refMarkerRef = self.refMarkerRef

    self.proj_cntrl.setMatrix(self.init_matrix)
    self.updateDisplay()
    self.d.enableAction()
    self.imageLabel.disable()
    self.imgLblItem.setSelected(0)
    transect.updateImageRef(self.refToImage, self.ds_cs, self.displayAltType)

  def enableLonLatGrid(self, event):
    if event.getSource().isSelected() == true:
      self.ll_grid.enable(self.ds_cs)
    elif event.getSource().isSelected() == false:
      self.ll_grid.disable()

  def enableImageLabel(self, event):
    if event.getSource().isSelected() == true:
      self.imageLabel.enable(self.ds_cs)
    elif event.getSource().isSelected() == false:
      self.imageLabel.disable()


  from java.lang import Double
  from visad import DisplayListener, DisplayEvent

  class linkHistLocation(DisplayListener):
    def __init__(self, display, scalar):
      self.x, self.y, self.z, self.display=subs.getDisplayMaps(display)
      self.dr = self.display.getDisplayRenderer()
      self.display.addDisplayListener(self)
      self.scalar=scalar
      self.called=0

    def displayChanged(self, event):
      if event.getId() == DisplayEvent.MOUSE_RELEASED:
        self.xx = self.dr.getDirectAxisValue(self.x)
        self.yy = self.dr.getDirectAxisValue(self.y)
        if not Double(self.xx).isNaN():
          if self.called==0:
            self.display.disableAction()
            range=self.scalar.getRange()
            self.val=[self.xx]
            self.display.enableAction()
            self.called=1
          else:
            self.display.disableAction()
            range=self.scalar.getRange()
            self.val.append(self.xx)         
            self.called=0
            self.scalar.setRange(min(self.val),max(self.val))
            self.display.enableAction()

            
  def doSetColorRangeD0(self,event):
    self.histTool = dragHistLocation(self.rgbMap, self.obs, imgRef=self.refToImage)
    
  def doGetLinCombD0(self,event):
    clc = ChannelLinearCombo(self)

  def doRGB(self,event):
    RGB_Combine(self)
    
  def doChangeParameter(self,event):
    if self.currentParam == "radiance":
      new_param       = "brightnessTemp"  
      menuText        = "BT->radiance"
    elif self.currentParam == "brightnessTemp":
      new_param         = "radiance"
      menuText          = "radiance->BT"
    
    self.obs, self.spectrum = self.ad.changeParameter(new_param,self.channelIndex, self.currentLine, self.currentElem)
    
    #- Rebuild image display
    
    self.observationsInstrument = self.ad.spectrumRangeType
    self.d.disableAction()
    self.d.removeReference(self.refToImage)
    self.d.removeMap(self.rgbMap)
    map = subs.makeMaps(self.ad.imageRangeType, "rgb")
    self.rgbMap = map[0]
    self.d.addMap(self.rgbMap)
    if self.currentProj == "Instrument" and (not(self.ad.instrumentName == "MSG" or self.ad.instrumentName == "GOES-E" or self.ad.instrumentName == "GOES-W" or self.ad.instrumentName == "GOES-10")):
      self.refToImage=subs.addData('a',self.obs,self.d, constantMaps=[ConstantMap(-0.2, Display.ZAxis)], renderer=getImageRenderer())
    else:
      self.refToImage=subs.addData('a',self.obs,self.d, constantMaps=[ConstantMap(-0.2, self.displayAltType)], renderer=getImageRenderer())
    self.colorMenu.changeColorScalarMap(self.rgbMap)
    self.updateImageText()
    self.updateDisplay()

    self.d.enableAction()

    #- Rebuild spectrum display
    self.d2.removeReference(self.lref)
    ###self.d2.removeReference(self.rrbzRef)

    if self.ad.instrumentName == "MODIS" or self.ad.instrumentName == "MSG" or self.ad.instrumentName == "GOES-E" or self.ad.instrumentName == "GOES_W" or self.ad.instrumentName == "AVHRR" or self.ad.instrumentName == "MSG_local":
      domain_range = self.ad.getObservationChannelRange()
      self.maps2[0].setRange(domain_range[0], domain_range[1])
      self.d2.removeAllReferences()
      self.d2.removeMap(self.maps2[1])
      self.d2.removeMap(self.maps2[2])
      map = subs.makeMaps(self.ad.spectrumRangeType.getComponent(0), "y")
      self.maps2[1] = map[0]
      map = subs.makeMaps(self.ad.spectrumRangeType.getComponent(1), "y")
      self.maps2[2] = map[0]
      as = self.maps2[2].getAxisScale()
      as.setVisible(1)
      as.setSide(1)
      as.setColor(Color.magenta)
      as = self.maps2[1].getAxisScale()
      as.setSide(0)
      as.setColor(hydra_properties.foreground_color)
      valid_range = self.ad.getObsValidRange()
      self.y0 = valid_range[0][0]
      self.y1 = valid_range[0][1]
      self.maps2[1].setRange(valid_range[0][0], valid_range[0][1])
      self.maps2[2].setRange(valid_range[1][0], valid_range[1][1])
      self.d2.addMap(self.maps2[1])
      self.d2.addMap(self.maps2[2])
      self.d2.disableAction()
      self.spectrumRef[0] = subs.addData('0',self.spectrum.getComponent(0),self.d2, subs.makeColorMap(hydra_properties.foreground_color))
      self.spectrumRef[1] = subs.addData('1',self.spectrum.getComponent(1),self.d2, subs.makeColorMap("magenta"))
      if self.refSpectrumRef != None:
        ll = self.refSpecDispListnr.currentLine
        ee = self.refSpecDispListnr.currentElem
        self.refSpectrumRef = subs.addData('2',self.ad.getObservations(ll,ee,true),self.d2,subs.makeColorMap("red"))
        self.refSpecDispListnr.refSpectrumRef = self.refSpectrumRef
        self.spectrumDiffRef = DataReferenceImpl('c')
        self.updateSpecDiff()
        self.d2.addReference(self.spectrumDiffRef, subs.makeColorMap('blue'))
        self.refSpecDispListnr.spectrumDiffRef = self.spectrumDiffRef
        self.d2.toggle(self.spectrumDiffRef, false)
        if self.specDiffToggleButton.isSelected() == true:
          self.d2.toggle(self.spectrumDiffRef, true)
      self.lref = subs.drawLine(self.d2,[(self.selChannel,self.selChannel),(valid_range[1][0],valid_range[1][1])],color="green")
      self.d2.enableAction()
    else:
      valid_range = self.ad.getObsValidRange()
      domain_range = self.ad.getObservationChannelRange()
      self.maps2[0].setRange(domain_range[0], domain_range[1])
      self.d2.removeAllReferences()
      self.d2.removeMap(self.maps2[1])
      map = subs.makeMaps(self.ad.spectrumRangeType, "y")
      self.maps2[1] = map[0]
      map[0].setRange(valid_range[0], valid_range[1])
      self.d2.addMap(map[0])
      as = self.maps2[1].getAxisScale()
      as.setSide(0)
      as.setVisible(1)
      as.setColor(hydra_properties.foreground_color)
      valid_range = self.ad.getObsValidRange()
      self.y0 = valid_range[0]
      self.y1 = valid_range[1]
      self.d2.disableAction()
      self.spectrumRef = subs.addData('b',self.spectrum,self.d2,subs.makeLineStyleMap('solid',1)+subs.makeColorMap(hydra_properties.foreground_color))
      if self.refSpectrumRef != None:
        ll = self.refSpecDispListnr.currentLine
        ee = self.refSpecDispListnr.currentElem
        self.refSpectrumRef = subs.addData('2',self.ad.getObservations(ll,ee,true),self.d2,subs.makeColorMap("red"))
        self.refSpecDispListnr.refSpectrumRef = self.refSpectrumRef
        self.spectrumDiffRef = DataReferenceImpl('c')
        self.updateSpecDiff()
        self.d2.addReference(self.spectrumDiffRef, subs.makeColorMap('blue'))
        self.refSpecDispListnr.spectrumDiffRef = self.spectrumDiffRef
        self.d2.toggle(self.spectrumDiffRef, false)
        if self.specDiffToggleButton.isSelected() == true:
          self.d2.toggle(self.spectrumDiffRef, true)
      self.lref = subs.drawLine(self.d2,[(self.selChannel,self.selChannel),(valid_range[0],valid_range[1])],color="green")
      self.d2.enableAction()

    ###self.rrbzRef = self.d2.enableRubberBandBoxZoomer ( 1 )
    self.changeMenu.setText(menuText)
    
    if new_param == "radiance":
      self.currentParam = new_param
    if new_param == "brightnessTemp":
      self.currentParam = new_param
   
    ll = self.ad.cs.toReference([[self.currentLine],[self.currentElem]])
    lat = ll[0][0]
    lon = ll[1][0]
    val = self.ad.getImageValue(lat, lon).getValue()
    roamText = Tuple(TupleType([self.obsLatitudeInstrument, self.obsLongitudeInstrument, self.text]), [Real(self.obsLatitudeInstrument, lat), Real(self.obsLongitudeInstrument, lon), Text(self.text, '   %-6.2f' % val)])
    self.roamTextRef.setData(roamText)

    transect.updateParameter(self.refToImage)

  def doTransect(self, event):
    #self.viewToolBar.select(ActionEvent(self,ActionEvent.ACTION_PERFORMED,"pick"),leftFunc="DIRECT")
    if self.viewToolBar != None:
      self.viewToolBar.select(ActionEvent(self,ActionEvent.ACTION_PERFORMED,"pick"))
      self.viewToolBar.buttonGroup.setSelected(self.viewToolBar.click.getModel(), true)
    ##transect.makeTransectDisplay(self.ad, self.obs, self.d, self.roamTextRef, self, lon_idx=1, lat_idx=0, dspAltLev=-0.98, altitudeMap=self.altitudeMap)
    transect.makeTransectDisplay(self.ad, self.obs, self.refToImage, self.d, self.roamTextRef, self, dspAltLev=0.0, altitudeMap=self.altitudeMap)
    
  def finishTransect(self):
    if self.viewToolBar != None:
      self.viewToolBar.select(ActionEvent(self,ActionEvent.ACTION_PERFORMED,"pick"))
      self.viewToolBar.buttonGroup.setSelected(self.viewToolBar.click.getModel(), true)
    
  def captureDisplay(self, event):
    Helper.saveDisplay(self.d, JFrame().getContentPane())
 
  def channelBoxChange(self, event):
    self.changeImage(float(self.instrumentString1.getText()), None)
  
  def imageStatToggle(self, event):
    if self.minmaxToggleButton.isSelected() == true:
      self.d.toggle(self.minRef, true)
      self.d.toggle(self.minMarkRef, true)
      self.d.toggle(self.maxRef, true)
      self.d.toggle(self.maxMarkRef, true)
    else:
      self.d.toggle(self.minRef, false)
      self.d.toggle(self.minMarkRef, false)
      self.d.toggle(self.maxRef, false)
      self.d.toggle(self.maxMarkRef, false)

  def spectrumDiffToggle(self, event):
    if self.specDiffToggleButton.isSelected() == true:
      if self.spectrumDiffRef == None:
        self.initSpectrumDiff()
      self.d2.toggle(self.spectrumDiffRef, true)
    else:
      self.d2.toggle(self.spectrumDiffRef, false)
  
  def initSpectrumDiff(self):
    self.specDiffType = None
    ##if len(self.diffMap_s) > 0:
    ##  for i in xrange(len(self.diffMap_s)):
    ##    self.d2.removeMap(self.diffMap_s[i])
    self.diffMap_s    = []
    if isinstance(self.ad.spectrumRangeType, RealTupleType):
      rt0 = RealType.getRealType("diff0")
      rt1 = RealType.getRealType("diff1")
      self.specDiffType = RealTupleType(rt0, rt1)
      self.diffMap_s.append(ScalarMap(rt0, Display.YAxis))
      self.diffMap_s.append(ScalarMap(rt1, Display.YAxis))
      self.d2.addMap(self.diffMap_s[0])
      self.d2.addMap(self.diffMap_s[1])
      valid_range = self.ad.getObsValidRange()
      self.diffMap_s[0].setRange(0,valid_range[0][1])
      self.diffMap_s[1].setRange(0,valid_range[1][1])
    else:
      self.specDiffType = RealType.getRealType("diff")
      #self.diffMap_s.append(ScalarMap(self.specDiffType, Display.YAxis))
      #self.d2.addMap(self.diffMap_s[0])
      #valid_range = self.ad.getObsValidRange()
      #self.diffMap_s[0].setRange(0, valid_range[1])

    ##self.d2.disableAction()
    if self.spectrumDiffRef != None:
      self.d2.removeReference(self.spectrumDiffRef)
    self.spectrumDiffRef = DataReferenceImpl('c')
    self.d2.addReference(self.spectrumDiffRef, subs.makeColorMap('blue'))
    self.updateSpecDiff()
    ##self.d2.addReference(self.spectrumDiffRef, subs.makeColorMap('blue'))
    ##self.d2.enableAction()


  def refSpectrumToggle(self, event):
    if self.refSpecToggleButton.isSelected() == true:
      if self.refSpectrumRef != None:
        self.d2.removeReference(self.refSpectrumRef)
    
      lat = self.ad.obsMin[0]
      lon = self.ad.obsMin[1]
      rt = geoPointRef_s[1].getData()
      if (self.ad.validateEarthPointOnImage(rt) == true):
        vals = rt.getValues()
        lat = vals[1]
        lon = vals[0]

      altVal = (self.altitudeMap.inverseScaleValues([0.2]))[0]
      refMark = RealTuple(RealTupleType([self.obsLatitudeInstrument, self.obsLongitudeInstrument, RealType.Altitude]), [Real(self.obsLatitudeInstrument, lat), Real(self.obsLongitudeInstrument, lon), Real(RealType.Altitude, altVal)], None)

      self.refMarkerRef = subs.addData('a',refMark,self.d,subs.makeColorMap('red')+[ConstantMap(0.2, self.displayAltType)], renderer=DirectManipulationRendererJ3D())

      self.lastrefMarker = refMark

      le = self.ad.cs.fromReference([[lat],[lon]])
      le = self.imageToSubset(le[0][0], le[1][0])
      refSpectrum = self.ad.getObservations(le[0], le[1], true)
      self.refSpectrumRef = subs.addData('c',refSpectrum,self.d2, subs.makeColorMap('red'))

      self.initSpectrumDiff()

      if self.specDiffToggleButton.isSelected() == true:
        self.d2.toggle(self.spectrumDiffRef, true)
      else:
        self.d2.toggle(self.spectrumDiffRef, false)

      self.updateGeoPoint(lon, lat, 1, true)

      from DisplayViewSelect import Pick
      self.h_action = Pick(self.viewToolBar.listeners, actionCommand="pick2", func="grab", icon=hydra_path+'/ui/icons/cursor12.jpg', border=CompoundBorder(LineBorder(Color(200,10,10),2), EmptyBorder(4,4,4,4)))
      self.viewToolBar.addHAction(self.h_action)

      class DspListnr(DisplayListener):
        def __init__(self, mcv, line, elem):
          self.dsp = mcv.d
          self.dsp.addDisplayListener(self)
          self.refMarkerRef = mcv.refMarkerRef
          self.last = mcv.refMarkerRef.getData()
          self.filereader = mcv.ad
          self.refSpectrumRef = mcv.refSpectrumRef
          self.spectrumRef = mcv.spectrumRef
          self.spectrumDiffRef = mcv.spectrumDiffRef
          self.mcv = mcv
          self.currentLine = line
          self.currentElem = elem

        def displayChanged(self, event):
          if event.getId() == 7:
            marker = self.refMarkerRef.getData()
            vals = self.refMarkerRef.getData().getValues()
            last_vals = self.last.getValues()
            if (visad.util.Util.isApproximatelyEqual(vals[0], last_vals[0]) and visad.util.Util.isApproximatelyEqual(vals[1],last_vals[1])):
              return
            else:
              vals = self.refMarkerRef.getData().getValues()
              lat  = vals[0]
              lon  = vals[1]
              self.mcv.updateGeoPoint(lon, lat, 1)
              self.last = marker

      self.refSpecDispListnr = DspListnr(self, le[0], le[1])
    else:
      self.viewToolBar.removeHAction(self.h_action)
      self.d.removeDisplayListener(self.refSpecDispListnr)
      self.d2.removeReference(self.refSpectrumRef)
      self.d2.removeReference(self.spectrumDiffRef)
      ##for i in xrange(len(self.diffMap_s)):
        ##self.d2.removeMap(self.diffMap_s[i])
      ##self.diffMap_s = []
      self.d.removeReference(self.refMarkerRef)
      self.refMarkerRef    = None
      self.refSpectrumRef  = None
      self.spectrumDiffRef = None
      if self.glb_spec_ref != None:
        self.refSpectrumRef = self.glb_spec_ref
        self.d2.addReference(self.glb_spec_ref, subs.makeColorMap('red'))

  def setGlobalSpectrumToggle(self, event):
    for i in xrange(len(hydra_globals.mcViewer_s)):
      mcv = hydra_globals.mcViewer_s[i]
      if (mcv != self):
        if self.glbSpecToggleButton.isSelected() == true:
          mcv.linkGlobalSpectrum(self.refSpectrumRef)
          self.glb_spec_ref = None
        else:
          mcv.unlinkGlobalSpectrum(self.refSpectrumRef)
        
  def windowClose(self, event):
    hydra_globals.mcViewer = None
    self.frame.dispose()
    (hydra_globals.dataSelectDict[self.dataSelect]).remove(self)
    runtime.gc()

  def getImageLonLatRange(self):
    import mapProjections

    if self.ad.instrumentName == "MSG":
      corners = [[-80, 80, -80, 80], [60, 60, -60, -60]]
    elif self.ad.instrumentName == "GOES-E":
      corners = [[-150, 10, -150, 10], [60, 60, -60, -60]]
    elif self.ad.instrumentName == "GOES-W":
      corners = [[-150, 10, -150, 10], [60, 60, -60, -60]]
    elif self.ad.instrumentName == "GOES-10":
      corners = [[-150, 10, -150, 10], [60, 60, -60, -60]]
    else:
      corners = mapProjections.getValidCorners(self.ad.gs, [[-180,180], [-90, 90]])
                                                                                                                                     
    minLon = min(corners[0])
    minLat = min(corners[1])
    maxLon = max(corners[0])
    maxLat = max(corners[1])
                                                                                                                                     
                                                                                                                                     
    self.lon_low = minLon
    self.lat_low = minLat
    self.lon_hi  = maxLon
    self.lat_hi  = maxLat

    
  def makeDisplaySpatialRealTypes(self):
    from visad import CommonUnit
    import mapProjections
    if self.ad.instrumentName == "MSG":
      corners = [[-80, 80, -80, 80], [60, 60, -60, -60]]
    elif self.ad.instrumentName == "GOES-E":
      corners = [[-150, 10, -150, 10], [60, 60, -60, -60]]
    elif self.ad.instrumentName == "GOES-W":
      corners = [[-150, 10, -150, 10], [60, 60, -60, -60]]
    elif self.ad.instrumentName == "GOES-10":
      corners = [[-150, 10, -150, 10], [60, 60, -60, -60]]
    else:
      corners = mapProjections.getValidCorners(self.ad.gs, [[-180,180], [-90, 90]])

    minLon = min(corners[0])
    minLat = min(corners[1])
    maxLon = max(corners[0])
    maxLat = max(corners[1])
                                                                                                                                                      
    self.lon_low = minLon
    self.lat_low = minLat
    self.lon_hi  = maxLon
    self.lat_hi  = maxLat
  

    displayLatType   = DisplayRealType("ProjectionLat_%d" % hydra_globals.dtuple_cnt, true, self.lat_low, self.lat_hi, 0.0, CommonUnit.degree)
    displayLonType   = DisplayRealType("ProjectionLon_%d" % hydra_globals.dtuple_cnt, true, self.lon_low, self.lon_hi, 0.0, CommonUnit.degree)
    displayAltType   = DisplayRealType("ProjectionAlt_%d" % hydra_globals.dtuple_cnt, true, -1.0, 1.0, 0.0, None)
    hydra_globals.dtuple_cnt += 1
                                                                                                                                                      
    from util import LambertEA, MapProjectionAdapter, SatProjection, PolarStereo

    if self.currentProj == "Lambert Equal Area":
      adaptProj  = MapProjectionAdapter(LambertEA(corners))
    elif self.currentProj == "Polar Stereographic":
      adaptProj  = MapProjectionAdapter(PolarStereo(corners))
    elif self.currentProj == "Instrument":
      adaptProj  = MapProjectionAdapter(SatProjection(self.ad.imageField, self.ad.invert, self.ad.cs))

    self.ds_cs = adaptProj

    displayTupleType = DisplayTupleType([displayLonType, displayLatType, displayAltType], adaptProj)
    
    return displayLonType, displayLatType, displayAltType

  def addImageText(self):
    ad = self.ad
    d  = self.d
    #-- min/max label
    minTuple = Tuple(TupleType([self.obsLatitudeInstrument, self.obsLongitudeInstrument, self.text]), [Real(self.obsLatitudeInstrument, ad.obsMin[0]), Real(self.obsLongitudeInstrument, ad.obsMin[1]), Text(self.text, '   %-6.2f' % ad.obsMin[2])])
    minMark = RealTuple(RealTupleType([self.obsLatitudeInstrument, self.obsLongitudeInstrument]), [Real(self.obsLatitudeInstrument, ad.obsMin[0]), Real(self.obsLongitudeInstrument, ad.obsMin[1])], None)
    self.minMarkRef = DataReferenceImpl('minMarkRef')
    self.minMarkRef.setData(minMark)
    self.d.addReference(self.minMarkRef, subs.makeColorMap(Color(0.8,0.8,0.0))+[ConstantMap(0.1, self.displayAltType)])
    self.minRef = DataReferenceImpl('minRef')
    self.minRef.setData(minTuple)
    self.d.addReference(self.minRef, subs.makeColorMap(Color(0.8,0.8,0.0))+[ConstantMap(0.1, self.displayAltType)])

    maxMark = RealTuple(RealTupleType([self.obsLatitudeInstrument, self.obsLongitudeInstrument]), [Real(self.obsLatitudeInstrument, ad.obsMax[0]), Real(self.obsLongitudeInstrument, ad.obsMax[1])], None)
    maxTuple = Tuple(TupleType([self.obsLatitudeInstrument, self.obsLongitudeInstrument, self.text]), [Real(self.obsLatitudeInstrument, ad.obsMax[0]), Real(self.obsLongitudeInstrument, ad.obsMax[1]), Text(self.text, '   %-6.2f' % ad.obsMax[2])])
    self.maxRef = DataReferenceImpl('maxRef')
    self.maxRef.setData(maxTuple)
    self.d.addReference(self.maxRef, subs.makeColorMap(Color(0.2, 0.8, 0.2))+[ConstantMap(0.1, self.displayAltType)])
    self.maxMarkRef = DataReferenceImpl('maxMarkRef')
    self.maxMarkRef.setData(maxMark)
    self.d.addReference(self.maxMarkRef, subs.makeColorMap(Color(0.2,0.8,0.2))+[ConstantMap(0.1, self.displayAltType)])
    self.imgTxtEnabled = true

  def updateImageText(self):
    if self.imgTxtEnabled == false:
      return

    minTuple = Tuple(TupleType([self.obsLatitudeInstrument, self.obsLongitudeInstrument, self.text]), [Real(self.obsLatitudeInstrument, self.ad.obsMin[0]), Real(self.obsLongitudeInstrument, self.ad.obsMin[1]), Text(self.text, '   %-6.2f' % self.ad.obsMin[2])])
    minMark = RealTuple(RealTupleType([self.obsLatitudeInstrument, self.obsLongitudeInstrument]), [Real(self.obsLatitudeInstrument, self.ad.obsMin[0]), Real(self.obsLongitudeInstrument, self.ad.obsMin[1])], None)
    self.minRef.setData(minTuple)
    self.minMarkRef.setData(minMark)
    maxMark = RealTuple(RealTupleType([self.obsLatitudeInstrument, self.obsLongitudeInstrument]), [Real(self.obsLatitudeInstrument, self.ad.obsMax[0]), Real(self.obsLongitudeInstrument, self.ad.obsMax[1])], None)
    maxTuple = Tuple(TupleType([self.obsLatitudeInstrument, self.obsLongitudeInstrument, self.text]), [Real(self.obsLatitudeInstrument, self.ad.obsMax[0]), Real(self.obsLongitudeInstrument, self.ad.obsMax[1]), Text(self.text, '   %-6.2f' % self.ad.obsMax[2])])
    self.maxRef.setData(maxTuple)
    self.maxMarkRef.setData(maxMark)

    tup = self.roamTextRef.getData()
    tup_type = tup.getType()
    c0 = tup.getComponent(0)
    c1 = tup.getComponent(1)
    val = self.ad.getImageValue(c0.getValue(),c1.getValue()).getValue()
    new_tup = Tuple(tup_type, [c0, c1, Text(self.text, '   %-6.2f' % val)])
    self.roamTextRef.setData(new_tup)

  def updateLocationLabel(self, lat, lon):
    strg='Lat = %-7.3f  Lon = %-8.3f' % (lat, lon)
    self.latLonStringInstrument.setText(strg)

  def updateDisplay(self, subset=None):
    if len(self.updateListeners) > 0:
      java.lang.Thread.sleep(5000)
    for i in xrange(len(self.updateListeners)):
      self.updateListeners[i].updateDisplay(subset)

  def addUpdateListener(self, oo):
    self.updateListeners.append(oo)

  def removeUpdateListener(self, oo):
    self.updateListeners.remove(oo)

  def linkGlobalSpectrum(self, glb_spec_ref):
    if self.refSpectrumRef == None:
      self.refSpectrumRef = glb_spec_ref
      self.glb_spec_ref = glb_spec_ref
      self.d2.addReference(glb_spec_ref, subs.makeColorMap('red'))
    else:
      self.viewToolBar.removeHAction(self.h_action)
      self.d2.removeReference(self.refSpectrumRef)
      self.d2.removeReference(self.spectrumDiffRef)
      ##for i in xrange(len(self.diffMap_s)):
        ##self.d2.removeMap(self.diffMap_s[i])
      self.refSpectrumRef = glb_spec_ref
      self.glb_spec_ref = glb_spec_ref
      self.refSpecToggleButton.setSelected(0)
      self.glbSpecToggleButton.setSelected(0)
      self.d2.addReference(glb_spec_ref, subs.makeColorMap('red'))
      self.d.removeReference(self.refMarkerRef)
  
  def unlinkGlobalSpectrum(self, glb_spec_ref):
    if self.refSpectrumRef == glb_spec_ref:
      self.refSpectrumRef = None
      self.glb_spec_ref = None
      self.d2.removeReference(glb_spec_ref)
    else:
      self.glb_spec_ref = None
      
  def importData(self, event):
    from visad.data.text import TextForm
    from visad.bom import BarbRendererJ3D
    txtForm = TextForm()
    windField = txtForm.open('/home/rink/data/TEST.TXT')
    spd_map = ScalarMap(RealType.getRealType('SPD'), Display.Flow1Radial)
    spd_map.setRange(0, 0.05)
    dir_map = ScalarMap(RealType.getRealType('DIR'), Display.Flow1Azimuth)
    dir_map.setRange(0, 360)
    self.d.addMap(spd_map)
    self.d.addMap(dir_map)
    self.d.addMap(ScalarMap(RealType.getRealType('PW'), Display.RGB))
    cntrl = spd_map.getControl()
    cntrl.setFlowScale(0.05)
    self.windRef = DataReferenceImpl('windRef')
    self.windRef.setData(windField)
    renderer = BarbRendererJ3D()
    renderer.setKnotsConvert(true)
    self.d.addReferences(renderer, self.windRef, [ConstantMap(0.3, self.displayAltType)]) 

  def getNavigatedImage(self, replace=true):
    return self.ad.getNavigatedImage(replace=replace)

  def getImageDisplay(self):
    return self.d

  def importLidar(self,event):
    import ldr_viewer
    if self.idv == None:
      ldr_viewer.start(self, None, platform='calipso')
    else:
      ldr_viewer.start(None, self.idv)

  def importCloudSat(self,event):
    import ldr_viewer
    ldr_viewer.start(self, None, platform='cloudsat')

  #------------------------------------------------------------------
  def __init__(self, ad, subset=None, ext_display=None, idv_displayMaster=None, dataSelect=None):
    self.ext_display = ext_display
    self.idv = None
    self.ad = ad
    self.last_spectralIndex = -1
    self.lastrefMarker = None
    self.refMarkerRef = None
    self.refSpectrumRef = None
    self.currentParam = ad.paramName
    self.currentLine  = 0
    self.currentElem  = 0
    self.currentProj = "Lambert Equal Area"
    if ad.instrumentName == "MSG" or ad.instrumentName == "GOES-E" or ad.instrumentName == "GOES-W" or ad.instrumentName == "GOES-10":
      self.currentProj = "Instrument"
    """
    if ad.instrumentName == "MSG_local":
      self.currentProj = "Instrument"
      ad.setUnnavigatedImage(true)
    """
    self.histTool  = None
    self.updateListeners = []
    self.currentSubset = subset
    hydra_globals.mcViewer_s.append(self)
    hydra_globals.mcViewer_cnt += 1
    self.spectrumDiffRef = None
    self.diffType = RealType.getRealType("diff")
    self.glb_spec_ref = None
    self.diffMap_s = []
    self.init_scale = None
    self.imgTxtEnabled = false
    self.viewToolBar = None
    self.imgXmap = None
    self.imgYmap = None

    self.dataSelect = dataSelect


    from lockCell import LockCell

    self.geoPtCell = LockCell(geoPointRef_s[0], self.updateSpectra)
    self.geoPtCell.addReference(geoPointRef_s[0])
    self.geoPtCell_1 = LockCell(geoPointRef_s[1], self.updateRefSpectra)
    self.geoPtCell_1.addReference(geoPointRef_s[1])
    self.geoPtCell_s = []
    self.geoPtCell_s.append(self.geoPtCell)
    self.geoPtCell_s.append(self.geoPtCell_1)

    
    obsElementInstrument, obsLineInstrument, obsChannelIndexInstrument, self.observationChannelsInstrument, self.observationsInstrument = ad.getRealTypes()
    self.obsLatitudeInstrument, self.obsLongitudeInstrument  = ad.getGeoRealTypes()
    obsLatMinMaxInstrument, obsLonMinMaxInstrument           = ad.getGeoDomain()
    self.text = TextType.Generic
    self.obsElementInstrument = obsElementInstrument
    self.obsLineInstrument    = obsLineInstrument

    self.observationChannelsInstrumentMX = ad.getObservationChannelRange()

    londiff = obsLonMinMaxInstrument[1] - obsLonMinMaxInstrument[0]
    latdiff = obsLatMinMaxInstrument[1] - obsLatMinMaxInstrument[0]
    if londiff >= latdiff:
      lon_low = obsLonMinMaxInstrument[0]
      lon_hi  = obsLonMinMaxInstrument[1]
      lat_low = obsLatMinMaxInstrument[0]
      lat_hi  = lat_low + londiff
    else:
      lat_low = obsLatMinMaxInstrument[0]
      lat_hi  = obsLatMinMaxInstrument[1]
      lon_low = obsLonMinMaxInstrument[0]
      lon_hi  = lon_low + latdiff

    numSegments=ad.getNumSegments()
    self.selSegment=0
    if ad.instrumentName == "MODIS":
      self.channel      = 32
      self.channelIndex = 32
    elif ad.instrumentName == "AVHRR":
      self.channel = 2
      self.channelIndex = 2
    elif ad.instrumentName == "MSG" or ad.instrumentName == "MSG_local":
      self.channel = 8
      self.channelIndex = 8
    elif ad.instrumentName == "AMSU_A":
      self.channel = 2
      self.channelIndex = 2
    else:
      self.channel=int(ad.numObsChannels/3)
      self.channelIndex = self.channel

    #Get the flat field
    self.obs = ad.getImageSegment(self.channel,self.selSegment,subset)

    #...and its dimensions
    dimInstrumentDom=self.obs.getDomainSet()
    self.dimInstrument=dimInstrumentDom.getLengths()
    #-self.dimInstrument=dimInstrumentDom.getHi()

    displayLonType, displayLatType, displayAltType = self.makeDisplaySpatialRealTypes()
    self.displayLonType = displayLonType
    self.displayLatType = displayLatType
    self.displayAltType = displayAltType

    self.maps = subs.makeMaps(self.obsLongitudeInstrument,'x', self.obsLatitudeInstrument, 'y', self.observationsInstrument, 'rgb','marker','shape', RealType.getRealType("BT"), 'rgb', self.text, 'text', RealType.XAxis, 'x', RealType.YAxis, 'y')
    #- replace first two with user-defined display types
    self.maps[0] = ScalarMap(self.obsLongitudeInstrument, displayLonType)
    self.maps[1] = ScalarMap(self.obsLatitudeInstrument, displayLatType)
    self.altitudeMap = ScalarMap(RealType.Altitude, displayAltType)
    self.altitudeMap.setRange(0,16000)
    self.maps.append(self.altitudeMap)
    #self.maps = self.maps+[ScalarMap(RealType.Altitude, displayAltType)]



    #hydra_idv test block
    if ext_display != None:
      d = ext_display
      self.displayLonType = idv_displayMaster.getDisplayLongitudeType()
      self.displayLatType = idv_displayMaster.getDisplayLatitudeType()
      self.displayAltType = idv_displayMaster.getDisplayAltitudeType()
      self.ds_cs = idv_displayMaster.getDisplayCoordinateSystem()
      self.idv_displayMaster = idv_displayMaster
    else:
      d = subs.makeDisplay(self.maps)
      # set the box size and turn off clipping
      subs.setBoxSize(d,.7,clip=0)
      ###subs.enableRubberBandBoxZoomer(d, 1)


    d.disableAction()

    mode = d.getGraphicsModeControl()
    mode.setCurvedSize(4)
    mode.setTextureEnable(hydra_globals.textureEnable)

    self.d = d
    dsp_rdr = self.d.getDisplayRenderer()
    dsp_rdr.setBackgroundColor(hydra_properties.background_color)
    dsp_rdr.setForegroundColor(hydra_properties.foreground_color)
    self.proj_cntrl  = self.d.getProjectionControl()
    self.init_matrix = self.proj_cntrl.getMatrix()

    self.maps[0].setRange(self.lon_low, self.lon_hi)
    self.maps[1].setRange(self.lat_low, self.lat_hi)
    self.maps[6].setRange(-1, 1)
    self.maps[7].setRange(-1, 1)
    self.rgbMap = self.maps[2]

    ir = getImageRenderer()

    map=load(hydra_path+'/data/outlsupw')
    #self.mapAdapter = BaseMapAdapter('./data/outlsupw')
    #self.mapAdapter.setLatLonLimits(self.lat_low-40, self.lat_hi+40, self.lon_low-40, self.lon_hi+40)
    #map = self.mapAdapter.getData()

    self.refToImage = DataReferenceImpl('image')
    self.refToImage.setData(self.obs)

    if ext_display == None:
      self.mapRef = subs.addData('map',map,d,constantMaps=subs.makeColorMap(hydra_properties.foreground_color)+[ConstantMap(-0.1, displayAltType)])

      if ((self.currentProj == "Instrument") and (not(ad.instrumentName == "MSG" or ad.instrumentName == "GOES-E" or ad.instrumentName == "GOES-W" or ad.instrumentName == "GOES-10"))):
        self.imgXmap = ScalarMap(self.obsElementInstrument, Display.XAxis)
        self.imgYmap = ScalarMap(self.obsLineInstrument, Display.YAxis)
        d.addMap(self.imgXmap)
        d.addMap(self.imgYmap)
        scale = jarray.zeros(2, 'f')
        offst = jarray.zeros(2, 'f')
        rect = self.ds_cs.getScaleOffset(scale, offst)
        self.imgXmap.setRange( (-1.0*scale[0] + offst[0]), (1.0*scale[0] + offst[0]))
        self.imgYmap.setRange( (-1.0*scale[1] + offst[1]), (1.0*scale[1] + offst[1]))
        d.addReferences(ir, self.refToImage, [ConstantMap(-0.2, Display.ZAxis)])
      else:
        d.addReferences(ir, self.refToImage, [ConstantMap(-0.2, self.displayAltType)])

    else:
      self.mapRef = DataReferenceImpl('map')
      self.mapRef.setData(map)
 
    
    self.shapes = None
    if ext_display == None:
    # enable the Listener for mouse up events
    # will only know about maps to Display.XAxis, YAxis made to this point
      subs.HandlePickEvent( d, self.doChangeSpectra, self.maps[6], self.maps[7])

    # finally, we want to have a small 'cross' to show the position
      self.shapes = subs.Shapes(d,self.maps[3], self.maps[6], self.maps[7])
      self.shapeMarkerIndex = self.shapes.addShape("cross",scale=.03,color="cyan", autoScale=0)
      self.shapeRef = self.shapes.shapeRef[self.shapeMarkerIndex]

    # initialize 'cross' marker
      ll = self.ad.cs.toReference([[self.currentLine],[self.currentElem]])
      lon = ll[1][0]
      lat = ll[0][0]
      rt = geoPointRef_s[0].getData()
      if (self.ad.validateEarthPointOnImage(rt) == true):
        vals = rt.getValues()
        lat = vals[1]
        lon = vals[0]
        le = self.ad.cs.fromReference([[lat],[lon]])
        le = self.imageToSubset(le[0][0], le[1][0])
        self.currentLine = le[0]
        self.currentElem = le[1]

      x = lat
      y = lon
      if self.ds_cs != None:
        ll = self.ds_cs.toReference([[lon],[lat],[0]])
        x = ll[0][0]
        y = ll[1][0]
      self.shapes.moveShape(self.shapeMarkerIndex,(x,y))

      self.updateGeoPoint(lon, lat, 0, true)

    #-- image display setup ------------------------------------------------------------------


    # GUI Setup
    from javax.swing import JSlider
    
    butPanelD0 = JPanel()
    buttColorRangeD0 = JButton("Set Color Range",actionPerformed=self.doSetColorRangeD0)
    butNaturalD0 = JPanel()
    butNaturalD0.setLayout(FlowLayout())
    butNaturalD0.add("West", buttColorRangeD0)
    butNaturalD0.setBackground(Color.black)

    butCombineLinChanD1 = JButton("Get Linear Combinations",actionPerformed=self.doGetLinCombD0)
    butNaturalD0.add("East",butCombineLinChanD1)

    sliderPanel = JPanel()
    sliderPanel.setLayout(BorderLayout())
    #hydra_idv test
    if ext_display == None:
      sliderPanel.add("Center",d.getComponent())
    if numSegments > 1: # only if more than one segment
      self.slider = JSlider(JSlider.VERTICAL,0,numSegments-1,self.selSegment,stateChanged=self.sliderchanged)
      sliderPanel.add("West",self.slider)

    textPanelD0 = JPanel()
    #textPanelD0.setLayout(GridLayout(0,1,5,5))
    textPanelD0.setLayout(GridLayout(1,0,5,5))
    self.instrumentString=JLabel('Instrument: '+ad.instrumentName)
    self.instrumentString.setForeground(hydra_properties.foreground_color)
    self.latLonStringInstrument=JLabel('Lat: ?, Lon: ?')
    self.latLonStringInstrument.setForeground(hydra_properties.foreground_color)
    self.timeStringInstrument=JLabel('Time: ?')
    self.timeStringInstrument.setForeground(hydra_properties.foreground_color)
    self.FOVangleStringInstrument=JLabel('FOV Angle: ?')
    self.FOVangleStringInstrument.setForeground(hydra_properties.foreground_color)
    textPanelD0.add(self.instrumentString)

    textPanelD0.add(self.latLonStringInstrument)
    """
    textPanelD0.add(self.timeStringInstrument)
    textPanelD0.add(self.FOVangleStringInstrument)
    """
    textPanelD0.setBackground(hydra_properties.background_color)

    InstrumentPanel = JPanel()
    InstrumentPanel.setLayout(BorderLayout())
    InstrumentPanel.add("Center",sliderPanel)
    InstrumentPanel.add("South",textPanelD0)
    

    self.roamTextRef = None
    self.txtCntrl = None
    if ext_display == None:
      subs.setPointSize(d, 4)
      txtCntrl = self.maps[5].getControl()
      txtCntrl.setJustification(TextControl.Justification.LEFT)
      txtCntrl.setAutoSize(1)
      txtCntrl.setFont(Font("sansserif", Font.PLAIN, 14))

      self.addImageText()
      roamText = Tuple(TupleType([self.obsLatitudeInstrument, self.obsLongitudeInstrument, self.text]), [Real(self.obsLatitudeInstrument, Float.NaN), Real(self.obsLongitudeInstrument, Float.NaN), Text(self.text, '   %-6.2f' % Float.NaN)])
      self.roamTextRef = DataReferenceImpl('roamText')
      self.roamTextRef.setData(roamText)
      self.d.addReference(self.roamTextRef, subs.makeColorMap(Color(1.0,0.0,1.0))+[ConstantMap(0.1, self.displayAltType)])
      self.txtCntrl = txtCntrl
      

    import ColorScaleSelect
    from ColorScaleSelect import ColorScaleSelect
    if self.ad.instrumentName == "MODIS_500m" or self.ad.instrumentName == "MODIS_250m":
      self.colorMenu = ColorScaleSelect("Set Color Scale", self.rgbMap, "Gray")
    else:
      self.colorMenu = ColorScaleSelect("Set Color Scale", self.rgbMap)

    from lonlatgrid import lonlatgrid
    self.ll_grid = lonlatgrid(self.d, self.ds_cs, self.colorMenu) 

    rot = jarray.zeros(3, 'd')
    scl = jarray.zeros(1, 'd')
    trn = jarray.zeros(3, 'd')
    mtr = self.proj_cntrl.getMatrix()
    MouseBehaviorJ3D.unmake_matrix(rot, scl, trn, mtr)
    self.init_scale = scl[0]

    from imagelabel import ImageLabel
    self.imageLabel = ImageLabel(self.d, self.ds_cs, self.init_scale, self.ad.instrumentName, self.ad.date_str, self.ad.time_str, self.obsLongitudeInstrument, self.obsLatitudeInstrument, self.colorMenu)


    #--------- now define the second panel:  single observation (full spectrum) at a pixel
    #-------------------------------------------------------------------------------------
    self.spectrum    = ad.getObservations(self.currentLine, self.currentElem)
    specDomain       = self.ad.observationDomain
    
    valid_range = ad.getObsValidRange()
    
    self.spectrumRef = None
    d2      = None
    self.d2 = None
    
    if ad.instrumentName == "MODIS" or ad.instrumentName == "MSG" or ad.instrumentName == "GOES-E" or ad.instrumentName == "GOES-W" or ad.instrumentName == "AVHRR" or ad.instrumentName == "MODIS_500m" or ad.instrumentName == "MODIS_250m" or ad.instrumentName == "MSG_local":
      self.maps2 = subs.makeMaps(self.observationChannelsInstrument,'x',ad.spectrumRangeType.getComponent(0),'y',ad.spectrumRangeType.getComponent(1),'y')
      as = self.maps2[2].getAxisScale()
      as.setVisible(1)
      as.setSide(1)
      self.maps2[2].setRange(valid_range[1][0], valid_range[1][1])
      self.maps2[1].setRange(valid_range[0][0], valid_range[0][1])
      d2 = subs.makeDisplay(self.maps2)
      self.d2 = d2
      dsp_rdr = self.d2.getDisplayRenderer()
      dsp_rdr.setBackgroundColor(hydra_properties.background_color)
      dsp_rdr.setForegroundColor(hydra_properties.foreground_color)
      self.spectrumRef = []
      self.spectrumRef.append(subs.addData('0',self.spectrum.getComponent(0), d2, subs.makeColorMap(hydra_properties.foreground_color)))
      self.spectrumRef.append(subs.addData('1',self.spectrum.getComponent(1), d2, subs.makeColorMap("magenta")))
      as.setColor(Color.magenta)
    else:
      self.maps2 = subs.makeMaps(self.observationChannelsInstrument,'x',self.observationsInstrument,'y')
      as = self.maps2[1].getAxisScale()
      as.setVisible(1)
      self.maps2[1].setRange(valid_range[0], valid_range[1])
      d2 = subs.makeDisplay(self.maps2)
      self.d2 = d2
      dsp_rdr = self.d2.getDisplayRenderer()
      dsp_rdr.setBackgroundColor(hydra_properties.background_color)
      dsp_rdr.setForegroundColor(hydra_properties.foreground_color)
      self.spectrumRef = subs.addData('b',self.spectrum,d2, subs.makeColorMap(hydra_properties.foreground_color))

    ###self.rrbzRef = self.d2.enableRubberBandBoxZoomer ( 1 )
    
    subs.setPointSize(d2, 4)
    showAxesScales(d2,1)
    subs.setAspectRatio(d2,2.2)
    subs.setBoxSize(d2,.6,clip=0)
    
    #-- update text labels
    self.ll = ad.cs.toReference([[0],[0]])
    strg='Lat = %-7.3f  Lon = %-8.3f' % (self.ll[0][0], self.ll[1][0])
    #self.latLonStringInstrument.setText(strg)
    self.updateLocationLabel(self.ll[0][0], self.ll[1][0])
    
    tt = ad.getTimeObs(0,0)
    strgTime = ""
    if tt != None:
      strgTime='Time = %-6.2f [offset (s)]' % (tt)
    self.timeStringInstrument.setText(strgTime)
    
    ff = ad.getFOVangleObs(0,0)
    strgFOV = ""
    if ff != None:
      strgFOV='FOV angle = %-6.2f [degrees]' % (ff)
    self.FOVangleStringInstrument.setText(strgFOV)


    self.selChannel=(specDomain.indexToValue([self.channel]))[0][0]
    if ad.instrumentName == "MODIS" or ad.instrumentName == "AVHRR" or ad.instrumentName == "MODIS_500m" or ad.instrumentName == "MODIS_250m":
      self.y0 = valid_range[1][0]
      self.y1 = valid_range[1][1]
    elif ad.instrumentName == "MSG" or ad.instrumentName == "GOES-E" or ad.instrumentName == "GOES-W" or ad.instrumentName == "MSG_local":
      self.y0 = valid_range[0][0]
      self.y1 = valid_range[0][1]
    else:
      self.y0 = valid_range[0]
      self.y1 = valid_range[1]
    self.lref = subs.drawLine(d2,[(self.selChannel,self.selChannel),(self.y0,self.y1)],color="green")

    subs.HandlePickEvent(d2, self.changeImage)
    
    textPanelD2 = JPanel()
    textPanelD2.setLayout(FlowLayout())
    xVariable=ad.getObservationChannels()
    
    channelText = None
    if ad.instrumentName == "MODIS" or ad.instrumentName == "MSG" or ad.instrumentName == "GOES-E" or ad.instrumentName == "GOES-W" or ad.instrumentName == "AVHRR" or ad.instrumentName == "MODIS_500m" or ad.instrumentName == "MODIS_250m" or ad.instrumentName == "MSG_local" or ad.instrumentName == "AMSU_A" or ad.instrumentName == "GOES-10":
      textPanelD2.add(JLabel("Band: "))
      self.bandNumberText = JComboBox(ad.band_numbers)
      self.bandNumberText.setSelectedItem(ad.band_numbers[ad.fileIndexes[self.channel]])
      
      class c1(java.awt.event.ActionListener):
        def __init__(self, mom, comboBox):
          self.mom = mom
          self.comboBox = comboBox
        def actionPerformed(self,event):
          self.mom.changeImage(self.mom.ad.bandNameToValue(self.comboBox.getSelectedItem()), None)
          
      self.bandNumberText.addActionListener(c1(self, self.bandNumberText))
      textPanelD2.add(self.bandNumberText)
      channelText = self.bandNumberText.getSelectedItem()
      
    strg=self.ad.observationDomain.getType().getDomain().toString()
    textPanelD2.add(JLabel(strg))
    strg = '%8.2f' % (xVariable[self.channel])
    if channelText == None:
      channelText = strg
    self.instrumentString1 = JTextField(strg, actionPerformed=self.channelBoxChange)
    textPanelD2.add(self.instrumentString1)
    unit = self.ad.observationDomain.getType().getDomain().getComponent(0).getDefaultUnit()
    if unit != None:     
      textPanelD2.add(JLabel(unit.toString()))


    SingleObsPanel = JPanel()
    SingleObsPanel.setLayout(BorderLayout())
    SingleObsPanel.add("Center",d2.getComponent())
    InstrumentPanel.add("North", textPanelD2)
    #------------------------------------------------------------------------------------
    
    #--- main window selection
    menuBar  = JMenuBar()
    toolMenu = JMenu("Tools")
    settingsMenu = JMenu("Settings")
    menuBar.add(toolMenu)
    menuBar.add(settingsMenu)

    importMenu   = JMenu("Import")
    menuBar.add(toolMenu)
    menuBar.add(settingsMenu)
    menuBar.add(importMenu)

    item = JMenuItem("Calipso", actionPerformed=self.importLidar)
    item.setEnabled(1)
    importMenu.add(item)

    item = JMenuItem("CloudSat", actionPerformed=self.importCloudSat)
    item.setEnabled(1)
    importMenu.add(item)
    
    item1 = JMenuItem("Set Color Range", actionPerformed=self.doSetColorRangeD0)
    item1.setEnabled(1)
    settingsMenu.add(item1)
    item2 = JMenuItem("Linear Combinations", actionPerformed=self.doGetLinCombD0)
    item2.setEnabled(1)
    toolMenu.add(item2)

    item = JMenuItem("rgb", actionPerformed=self.doRGB)
    item.setEnabled(1)
    toolMenu.add(item)

    self.changeMenu = JMenuItem("BT->radiance", actionPerformed=self.doChangeParameter)
    self.changeMenu.setEnabled(1)
    settingsMenu.add(self.changeMenu)
    item4 = JMenuItem("Transect", actionPerformed=self.doTransect)
    item4.setEnabled(1)
    toolMenu.add(item4)
    item5 = JMenuItem("Capture Display", actionPerformed=self.captureDisplay)
    item5.setEnabled(1)
    toolMenu.add(item5)
    
    statMenu = JMenu("Statistics")
    self.minmaxToggleButton = JRadioButtonMenuItem("Min/Max", actionPerformed=self.imageStatToggle)
    self.minmaxToggleButton.setSelected(1)
    statMenu.add(self.minmaxToggleButton)
    toolMenu.add(statMenu)

    menu = JMenu("Reference Spectrum")
    self.refSpecToggleButton = JRadioButtonMenuItem("On", actionPerformed=self.refSpectrumToggle)
    self.refSpecToggleButton.setSelected(0)
    menu.add(self.refSpecToggleButton)
    self.glbSpecToggleButton = JRadioButtonMenuItem("global", actionPerformed=self.setGlobalSpectrumToggle)
    self.glbSpecToggleButton.setSelected(0)
    menu.add(self.glbSpecToggleButton)
    self.specDiffToggleButton = JRadioButtonMenuItem("diff",actionPerformed=self.spectrumDiffToggle)
    menu.add(self.specDiffToggleButton)
    toolMenu.add(menu)
    
    projMenu = JMenu("Projection")
    lcItem = JRadioButtonMenuItem("Lambert Equal Area", actionPerformed=self.changeProjection)
    psItem = JRadioButtonMenuItem("Polar Stereographic", actionPerformed=self.changeProjection)
    isItem = JRadioButtonMenuItem("Instrument", actionPerformed=self.changeProjection)
    lcItem.setEnabled(1)
    psItem.setEnabled(1)
    isItem.setEnabled(1)
    if self.currentProj == "Lambert Equal Area":
      lcItem.setSelected(1)
    elif self.currentProj == "Polar Stereographic":
      psItem.setSelected(1)
    elif self.currentProj == "Instrument":
      isItem.setSelected(1)
    bg = ButtonGroup()
    bg.add(lcItem)
    bg.add(psItem)
    bg.add(isItem)
    projMenu.add(lcItem)
    projMenu.add(psItem)
    projMenu.add(isItem)
    settingsMenu.add(projMenu)
    
    settingsMenu.add(self.colorMenu)

    lonlatgridMenu = JMenu("Lon/Lat Grid")
    item = JRadioButtonMenuItem("enabled", actionPerformed=self.enableLonLatGrid)
    item.setSelected(0)
    item.setEnabled(1)
    lonlatgridMenu.add(item)
    settingsMenu.add(lonlatgridMenu)

    imgLblMenu = JMenu("Image Label")
    item = JRadioButtonMenuItem("enabled", actionPerformed=self.enableImageLabel)
    item.setSelected(0)
    item.setEnabled(1)
    imgLblMenu.add(item)
    settingsMenu.add(imgLblMenu)
    self.imgLblItem = item
    

    frame = HFrame("Multi-Channel Viewer",windowClosing=self.windowClose)
    #-test
    frame.ll_grid = self.ll_grid
    frame.imageLabel = self.imageLabel
    frame.setJMenuBar(menuBar)
    pane = frame.getContentPane()
    pane.setLayout(BorderLayout())
    
    from DisplayViewSelect import DisplayViewSelectToolBar

    splitpane = JSplitPane(JSplitPane.VERTICAL_SPLIT)
    SingleObsPanel.setPreferredSize(Dimension(500,220))
    splitpane.add(SingleObsPanel)
    splitpane.add(InstrumentPanel)    
    splitpane.setContinuousLayout(1)
    splitpane.setOneTouchExpandable(1)
    splitpane.setDividerSize(12)
  
    pane.add("Center", splitpane)
    if ext_display == None:
      self.viewToolBar = DisplayViewSelectToolBar([self.d, self.d2], [0, 1])    
      pane.add("South", self.viewToolBar)
      import roamProbe
      from roamProbe import roamProbe
      roamProbe(d, ad, self.viewToolBar, self.roamTextRef, self.obsLatitudeInstrument, self.obsLongitudeInstrument, self.text, ad.getImageValue)

    self.d.enableAction()

    #import roamProbe
    #from roamProbe import roamProbe
    #roamProbe(d, ad, self.viewToolBar, self.roamTextRef, self.obsLatitudeInstrument, self.obsLongitudeInstrument, self.text)

    frame.pack()
    frame.show()
    frame.setSize(500,700)
    frame.setVisible(1)
    frame.addVisADDisplay(self.d)
    frame.addVisADDisplay(self.d2)
    self.frame = frame


  def buildImageDisp(self):
    pass    

#----------------------------------------------------------------------------------

class linkHistLocation(DisplayListener):
  def __init__(self, display, scalar):
    self.x, self.y, self.z, self.display=subs.getDisplayMaps(display)
    self.dr = self.display.getDisplayRenderer()
    self.display.addDisplayListener(self)
    self.scalar=scalar
    self.called=0

  def displayChanged(self, event):
    if event.getId() == DisplayEvent.MOUSE_RELEASED:
      self.xx = self.dr.getDirectAxisValue(self.x)
      self.yy = self.dr.getDirectAxisValue(self.y)
      if not Double(self.xx).isNaN():
        if self.called==0:
          self.display.disableAction()
          self.val=[self.xx]
          self.display.enableAction()
          self.called=1
        else:
          self.display.disableAction()
          self.val.append(self.xx)         
          self.called=0
          self.scalar.setRange(min(self.val),max(self.val))
          self.display.enableAction()
