from javax.swing import JFrame, JPanel
from java.lang import System
from java.awt.event import WindowListener, MouseAdapter

sys_name = System.getProperty('os.name')

#------------------------------------------------------------------
#- workaround for Mac window resizing problem:  garbage
#  in the display when resizing window or divider.
#
#- Use:  just like JFrame, except you must register the contained
#  VisAD Displays with self.addVisADDisplay(d), d: the Display obj
#------------------------------------------------------------------
class HFrame(JFrame, WindowListener):
  def __init__(self, title=None, windowClosing=None):
    JFrame.__init__(self,title)
    self.pane      = JFrame.getContentPane(self)
    self.big_panel = JPanel()
    self.pane.add(self.big_panel)
    self.vdisplays = []
    self.addWindowListener(self)
    self.wclosing = windowClosing
    self.last_time = System.currentTimeMillis()
    self.last_height = 500
    self.last_width  = 500
    self.fraction = 1.10
    self.ll_grid = None
    self.imageLabel = None
    
  def windowOpened(self,event):
    pass

  def windowClosing(self,event):
    if self.wclosing != None:
      self.wclosing(event)

  def windowClosed(self,event):
    pass

  def windowDeiconified(self,event):
    pass
    """
    if sys_name.find('Mac') >= 0:
      cnvs_s = []
      for i in xrange(len(self.vdisplays)):
        cnvs = self.vdisplays[i].getDisplayRenderer().getCanvas()
        cnvs.stopRenderer()
        cnvs_s.append(cnvs)
      self.pane.remove(self.big_panel)
      self.pane.add(self.big_panel)
      for i in xrange(len(self.vdisplays)):
        cnvs_s[i].startRenderer()
      for i in xrange(len(self.vdisplays)):
        self.vdisplays[i].reDisplayAll()
    """

  def windowActivated(self,event):
    pass
  def windowDeactivated(self,event):
    pass
  def windowIconified(self,event):
    pass

  def getContentPane(self):
    return self.big_panel

  def addVisADDisplay(self, d):
    self.vdisplays.append(d)
    if len(self.vdisplays) == 1:
      size = self.vdisplays[0].getDisplayRenderer().getCanvas().getSize()
      self.last_height = size.height
      self.last_width = size.width

  def paint(self, graphics):
    JFrame.paint(self,graphics)
    if len(self.vdisplays) > 0:
      size = self.vdisplays[0].getDisplayRenderer().getCanvas().getSize()
      hrat = float(size.height)/float(self.last_height)
      if (hrat > self.fraction or hrat < 1.0/self.fraction):
        if self.ll_grid != None:
          self.ll_grid.update()
        if self.imageLabel != None:
          self.imageLabel.update()
        self.last_height = size.height

class HMouseAdapter(MouseAdapter):
  def __init__(self):
    MouseAdapter.__init__(self)

  def mouseReleased(self, event):
    print event
