import sys
import jarray
sys.path.append('multispectral/Lib/file')
from visad.python.JPythonMethods import *
import netcdfhelper
import HDF4File
from HDF4File import *
from subs import *
from graph import *
from visad import Linear2DSet, FlatField, Gridded1DSet, Gridded2DDoubleSet, Set, Unit, CommonUnit, OffsetUnit
from visad import Gridded1DDoubleSet, CoordinateSystem, Integer2DSet, Integer3DSet, DoubleSet, SetType, FloatSet
from visad import DisplayRenderer, MouseHelper, Real, GraphicsModeControl, DisplayListener, DisplayEvent
from visad import BaseColorControl, Gridded3DDoubleSet
from visad.util import VisADSlider
from visad.java3d import DirectManipulationRendererJ3D, DefaultRendererJ3D, DisplayImplJ3D
from java.lang import Math, Float, Double, Class
from javax.swing import JPanel, JButton, JMenuBar, JMenu, JMenuItem
from java.awt import FlowLayout, GridLayout, BorderLayout
from visad.bom import RubberBandBoxRendererJ3D
from util import OneDProbeRendererJ3D, Helper
from subsetImage import SubsetImage, Subset
from ui.colorbar import ColorBarWidget
from visad.data.units import *

import hydra_globals
from hydra_globals import hydra_path
                                                                                                                     
false = 0
true  = 1


altType = makeType("altitude")
unit = Parser.parse("seconds since 1993-01-01 00:00:00Z")
trackType = makeType("track")
tabType = makeType("tot_attn_back")
depolarType = makeType("depolarization")


def depolarization(data_s):
  dataA = data_s[0]
  dataB = data_s[1]
  result = Helper.B_divideBy_AminusB(dataA, dataB);
  return result


def makeDepolarizationColorFunction():
    red = jarray.zeros(256, 'f')
    grn = jarray.zeros(256, 'f')
    blu = jarray.zeros(256, 'f')
    vis5d_tbl = BaseColorControl.initTableVis5D([red,grn,blu])
    tbl_len = len(vis5d_tbl[0])
    fsmpls = jarray.zeros(tbl_len+1, 'f')
    colors = []
    colors.append(jarray.zeros(tbl_len+1, 'f'))
    colors.append(jarray.zeros(tbl_len+1, 'f'))
    colors.append(jarray.zeros(tbl_len+1, 'f'))
    fsmpls[0] = -1
    colors[0][0] = 0.0
    colors[1][0] = 0.0
    colors[1][0] = 0.0
    fval = 0
    for i in xrange(tbl_len):
      fsmpls[i+1] = fval + i*(1./(tbl_len-1))
      colors[0][i+1] = vis5d_tbl[0][i]
      colors[1][i+1] = vis5d_tbl[1][i]
      colors[2][i+1] = vis5d_tbl[2][i]
    set = Gridded1DSet(RealType.Generic, [fsmpls], tbl_len+1)
    clr_fnc = FlatField(FunctionType(RealType.Generic, RealTupleType([makeType("cR"), makeType("cG"), makeType("cB")])), set)
    clr_fnc.setSamples(colors)
    return clr_fnc
    
    

def makeColorTable():
    red_c=[0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,42.5,85.0,127.5,170.0,212.5,255.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,42.5,85.0,127.5,170.0,212.5,255.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,42.5,85.0,127.5,170.0,212.5,255.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,42.5,85.0,127.5,170.0,212.5,255.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,42.5,85.0,127.5,170.0,212.5,255.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,255.0,255.0,255.0,255.0,255.0,
           0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,255.0,255.0,255.0,255.0,255.0,
           0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,255.0,255.0,255.0,255.0,255.0,
           0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,255.0,255.0,255.0,255.0,255.0,
           0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,255.0,255.0,255.0,255.0,255.0,
           0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,255.0,255.0,255.0,255.0,255.0,
           42.5,85.0,127.5,170.0,212.5,42.5,85.0,127.5,170.0,212.5,
           42.5,85.0,127.5,170.0,212.5,42.5,85.0,127.5,170.0,212.5,42.5,85.0,127.5,170.0,212.5]
                                                                                                                                           
    green_c=[0.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,
             255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,
             255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,
             255.0,255.0,255.0,255.0,255.0,255.0,255.0,212.5,212.5,212.5,212.5,212.5,212.5,212.5,
             170.0,170.0,170.0,170.0,170.0,170.0,170.0,127.5,127.5,127.5,127.5,127.5,127.5,127.5,
             85.0,85.0,85.0,85.0,85.0,85.0,85.0,42.5,42.5,42.5,42.5,42.5,42.5,42.5,
             0.0,0.0,0.0,0.0,0.0,0.0,0.0,
             212.5,170.0,127.5,85.0,42.5,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,
             212.5,170.0,127.5,85.0,42.5,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,
             212.5,170.0,127.5,85.0,42.5,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,
             212.5,170.0,127.5,85.0,42.5,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,
             212.5,170.0,127.5,85.0,42.5,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,
             212.5,170.0,127.5,85.0,42.5,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,
             42.5,42.5,42.5,42.5,42.5,85.0,85.0,85.0,85.0,85.0,
             127.5,127.5,127.5,127.5,127.5,170.0,170.0,170.0,170.0,170.0,212.5,212.5,212.5,212.5,212.5]
                                                                                                                                           
    blue_c=[0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,42.5,42.5,42.5,42.5,42.5,42.5,
            85.0,85.0,85.0,85.0,85.0,85.0,85.0,127.5,127.5,127.5,127.5,127.5,127.5,127.5,
            170.0,170.0,170.0,170.0,170.0,170.0,170.0,212.5,212.5,212.5,212.5,212.5,212.5,212.5,
            255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,
            255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,
            255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,
            255.0,255.0,255.0,255.0,255.0,255.0,255.0,
            212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,
            170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,
            127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,
            85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,
            42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,
            0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
            0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
            0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]
    g_scale = [70,100,130,155,180,200,225,235,240,242,245,249,253]
                                                                                                                                           
    for i in xrange(len(red_c)):
      red_c[i] /= 255.0
      green_c[i] /= 255.0
      blue_c[i] /= 255.0
                                                                                                                                           
    for j in xrange(len(g_scale)):
      red_c[10+j] = g_scale[j]/255.0
      green_c[10+j] = g_scale[j]/255.0
      blue_c[10+j] = g_scale[j]/255.0
                                                                                                                                           
    indexes = []
    ff = open(hydra_path+'/ancillary/lidar/Colors_532.txt')
    lines = ff.readlines()
    nlines = len(lines)
    for i in xrange(nlines):
      fields = lines[i].split()
      indexes.append(int(fields[0]))
                                                                                                                                           
    red   = []
    green = []
    blue  = []
                                                                                                                                           
    for i in xrange(nlines):
      red.append(red_c[indexes[i]])
      green.append(green_c[indexes[i]])
      blue.append(blue_c[indexes[i]])

    return [red, green, blue]


def makeCloudSatColorTable():
    ff = open(hydra_path+'/ancillary/cloudsat/colortable.txt')
    lines = ff.readlines()
    nlines = len(lines)
    red = []
    green = []
    blue = []

    for i in xrange(nlines):
      fields = lines[i].split()
      red.append(float(fields[0]))
      green.append(float(fields[1]))
      blue.append(float(fields[2]))
                                                                                                                      
    for i in xrange(len(red)):
      red[i] /= 255.0
      green[i] /= 255.0
      blue[i] /= 255.0
                                                                                                                      
    return [red, green, blue]


class LidarLogCoordinateSystem(CoordinateSystem):
  def __init__(self, reference):
    CoordinateSystem.__init__(self, reference, [None])
                                                                                                                                    
  def toReference(self, values):
    new_values = jarray.zeros(len(values[0]), 'f')
    for i in xrange(len(values[0])):
      if values[0][i] <= 0.0:
        new_values[i] = -12.0
      else:
        new_values[i] = Math.log(values[0][i])/Math.log(10)
    return [new_values]
                                                                                                                                    
  def fromReference(self, values):
    new_values = jarray.zeros(len(values[0]), 'f')
    for i in xrange(len(values[0])):
      if values[0][i] == -12.0:
        new_values[i] = 0.0
      else:
        new_values[i] = Math.pow(10, values[0][i])
    return [new_values]


log_tabType =  makeType("(log_tot_attn_back)")
log_cs = LidarLogCoordinateSystem(log_tabType)
#tabType = RealTupleType(makeType("tot_attn_back"), log_cs, None)


def makeEmptyMetadataTable():
  table = {'longitudeName':None, 'latitudeName':None,'profileTimeName':None,'sfcElevName':None,
           'dataRange':None, 'colorTable':None, 'datasetName':None,'trackDimName':None, 'vertDimName':None,
           'altValuesLR':None, 'altValuesHR':None, 'track_skip':None, 'track_start':None, 'vert_skip':None,
           'vert_start':None, 'instrumentName':None, 'track_skipHR':None}
  return table

def fillMetadataTable(instrName):
  table = makeEmptyMetadataTable()

  if instrName == 'calipso':
    table['longitudeName'] = 'Longitude'
    table['latitudeName'] = 'Latitude'
    table['profileTimeName'] = 'Profile_Time'
    table['sfcElevName'] = 'Surface_Elevation'
    table['dataRange'] = [1.0E-04, 1.0E-01]
    table['datasetName'] = 'Total_Attenuated_Backscatter_532'
    table['trackDimName'] = 'fakeDim38'
    table['vertDimName'] = 'fakeDim39'
    table['colorTable'] = makeColorTable()
    table['instrumentName'] = instrName
    table['track_skip'] = 100
    table['track_start'] = 0
    table['vert_skip'] = 5
    table['vert_start'] = 0
    table['track_skipHR'] = 8

    altValues = []
    ff       = open(hydra_path+'/ancillary/lidar/altitudeLR_25km', 'r')
    lines    = ff.readlines()
    nlines   = len(lines)
    for i in xrange(nlines):
      fields = lines[i].split()
      altValues.append(float(fields[0]))

    table['altValuesLR'] = altValues

    altValues_all = []
    ff       = open(hydra_path+'/ancillary/lidar/altitude_25km', 'r')
    lines    = ff.readlines()
    nlines   = len(lines)
    for i in xrange(nlines):
      fields = lines[i].split()
      altValues_all.append(float(fields[0]))
    
    table['altValuesHR'] = altValues_all
    

  if instrName == 'cloudsat':
    table['longitudeName'] = 'Longitude'
    table['latitudeName'] = 'Latitude'
    table['profileTimeName'] = 'Profile_time'
    #table['sfcElevName'] = 'Surface_Elevation'
    table['dataRange'] = [-40, 50]
    table['datasetName'] = 'Radar_Reflectivity'
    table['trackDimName'] = 'nray:2B-GEOPROF'
    table['vertDimName'] = 'nbin:2B-GEOPROF'
    table['colorTable'] = makeCloudSatColorTable()
    table['instrumentName'] = instrName
    table['track_skip'] = 100
    table['track_start'] = 0
    table['vert_skip'] = 1
    table['vert_start'] = 0
    table['track_skipHR'] = 1

    altValues = []
    ff       = open(hydra_path+'/ancillary/cloudsat/altitudeHR', 'r')
    lines    = ff.readlines()
    nlines   = len(lines)
    for i in xrange(nlines):
      fields = lines[i].split()
      altValues.append(float(fields[0]))
                                                                                                                                           
    table['altValuesLR'] = altValues
    table['altValuesHR'] = altValues

  return table


def getStartStopTime(instrName, reader, time_range):
  if instrName == 'calipso':
    return time_range

  if instrName == 'cloudsat':
    start_time = reader.getValues('TAI_start', [0], [1], [1])
    return [start_time[0], start_time[0]+time_range[1]]


class DataCoords:
  def __init__(self, start, stride, count):
    self.start = start
    self.stride = stride
    self.count = count


class CurtainDisplay2D:
  def __init__(self, domainSet, dataSetName, dataCoords, colorTable, x_type, x_range, x_init, y_type, y_range, dataType, dataRange, reader, dataProducer):
    self.domainSet = domainSet
    self.dataSetName = dataSetName
    self.x_init = x_init
    self.y_range = y_range
    self.dataType = dataType
    self.dataProducer = dataProducer
 
    start = dataCoords.start
    count = dataCoords.count
    stride = dataCoords.stride

    field = FlatField(FunctionType(domainSet.getType().getDomain(), dataType), domainSet)

    rangeValues = dataProducer.getData(dataCoords)
    rangeValues = Helper.smooth(rangeValues, count[1], count[0], 3.0, 2)
    #rangeValues = Helper.medianFilter(rangeValues,  count[1], count[0], 7, 15)

    field.setSamples([rangeValues], false)

    maps = []
    maps.append(ScalarMap(y_type, Display.YAxis))
    maps.append(ScalarMap(x_type, Display.XAxis))
    maps.append(ScalarMap(dataType, Display.RGB))
    maps[0].setRange(y_range[0], y_range[1])
    maps[1].setRange(x_range[0], x_range[1])
    maps[2].setRange(dataRange[0], dataRange[1])

    display2D = makeDisplay(maps)
    gmc = display2D.getGraphicsModeControl()
    gmc.setLineWidth(2)
    display2D.disableAction()
    self.imgRef = display2D.addData(self.dataSetName, field)
    display2D.setAspectRatio(2)
    display2D.setBoxSize(percent=0.80)
    display2D.showAxesScales(1)
    gmc.setMissingTransparent(false)
    dsp_rdr = display2D.getDisplayRenderer()
    dsp_rdr.setClip(2, true, 0.0, 1.0, 0.0, -0.5)
    dsp_rdr.setClip(3, true, 0.0, -1.0, 0.0, -0.5)


    if colorTable != None:
      if isinstance(colorTable, Class.forName('visad.FlatField')):
        maps[2].getControl().setFunction(colorTable)
      else:
        maps[2].getControl().setTable(colorTable)
    display2D.enableAction()

    self.display = display2D
    self.maps = maps
    self.field = field
    self.reader = reader
    self.hrImageRef = self.display.addData(self.dataSetName, RealTuple(RealTupleType(x_type, y_type), [0.0, 0.0]))
    self.hrBoxRef = self.display.addData(self.dataSetName, RealTuple(RealTupleType(x_type, y_type), [0.0, 0.0]))
    self.hrMeshRef = DataReferenceImpl('mesh')

  def getDisplay(self):
    return self.display

  def addData(self, name, data):
    self.display.addData(name, data)

  def update(self, domainSet, dataCoords):
    start = dataCoords.start
    count = dataCoords.count
    stride = dataCoords.stride

    values = self.dataProducer.getData(dataCoords)
    #values = Helper.smooth(values, count[1], count[0], 2.5, 2)
    values = Helper.medianFilter(values, count[1], count[0], 7, 15)

    field = FlatField(FunctionType(domainSet.getType().getDomain(), self.dataType), domainSet, None, None, [FloatSet(SetType(self.dataType))], None)
    field.setSamples([values], false)
    self.hrImageRef.setData(field)

  def updateBox(self, set):
    lo = set.getLow()
    hi = set.getHi()

    sets = []
    sets.append(Gridded2DSet(set.getType().getDomain(), [[lo[0],lo[0]], [lo[1],hi[1]]], 2))
    sets.append(Gridded2DSet(set.getType().getDomain(), [[lo[0],hi[0]], [hi[1],hi[1]]], 2))
    sets.append(Gridded2DSet(set.getType().getDomain(), [[hi[0],hi[0]], [hi[1],lo[1]]], 2))
    sets.append(Gridded2DSet(set.getType().getDomain(), [[hi[0],lo[0]], [lo[1],lo[1]]], 2))

    self.hrBoxRef.setData(UnionSet(sets))


  def getRGBMap(self):
    return self.maps[2]

  def getXmap(self):
    return self.maps[1]

  def getYmap(self):
    return self.maps[0]

  def getImage(self):
    return self.imgRef.getData()

  def getImageRef(self):
    return self.imgRef

  def getHRImageRef(self):
    return self.hrImageRef

  def setTimeProbe(self, selectRef, callback):

    class lineCell(CellImpl):
      def __init__(self, display, selectRef, y_range, x_init, callback):
        self.y_range   = y_range
        self.display   = display
        self.selectRef = selectRef
        self.callback  = callback
        self.lineRefL  = display.drawLine([[x_init, x_init], [self.y_range[0], self.y_range[1]]], color="cyan", width=2)

      def doAction(self):
        val = self.selectRef.getData().getValue()
        self.display.moveLine(self.lineRefL, [[val, val], [self.y_range[0], self.y_range[1]]])
        if self.callback != None:
          self.callback(val)

    lcell = lineCell(self.display, selectRef, self.y_range, self.x_init, callback)
    lcell.addReference(selectRef)


class DataDefinition:
  def __init__(self, datasetName, start, count, stride):
    self.datasetName = datasetName
    self.start = start
    self.count = count
    self.stride = stride

  def equals(dataDef):
    if (dataDef.datasetName != self.datasetName):
      return false
    else:
      return true


class DataRetriever:
  def __init__(self, reader):
    self.reader = reader

  def getData(self, descr):
    values = self.reader.getValues(descr.datasetName, descr.start, descr.count, descr.stride)
    return values


class DataProducer:
  def __init__(self, dataRetrieve=None, datasetName=None):
    self.dataRetrieve = dataRetrieve
    self.datasetName = datasetName

    self.last_data = None
    self.last_descr = None

  def getData(self, descr):
    data = None
    if self.last_descr != descr:
      data = self.dataRetrieve.getData(DataDefinition(self.datasetName, descr.start, descr.count, descr.stride))
    else:
      data = self.last_data
    self.last_data = data
    self.last_descr = descr
    return data



class CloudSatRadarReflectivity(DataProducer):
  def __init__(self, dataRetrieve, datasetName):
    DataProducer.__init__(self, dataRetrieve, datasetName)

  def getData(self, descr):
    data = DataProducer.getData(self, descr)
    new_data = Helper.unpack(data, 0.01, 0)
    return new_data

class DerivedDataProducer:
   def __init__(self, dataProducers, derivedName, compute=None):
     self.dataProducers = dataProducers
     self.derivedName = derivedName
     self.compute = compute

   def getData(self, descr):
     data_s = []
     for i in xrange(len(self.dataProducers)):
       data_s.append(self.dataProducers[i].getData(descr))
     return self.compute(data_s)

class DataSmoother:
   def __init__(self, dataProducer):
     self.dataProducer

   def getData(self, descr):
     data = self.dataProducer.getData(descr)
     data = Helper.smooth(data, descr.count[1], descr.count[0], 3.0, 2)
     return data


def getDataProducer(reader, dataSetName):
   dataProducer = None
   if dataSetName == 'Total_Attenuated_Backscatter_532':
     dataProducer = DataProducer(DataRetriever(reader), dataSetName)
   if dataSetName == 'Radar_Reflectivity': 
     dataProducer = CloudSatRadarReflectivity(DataRetriever(reader), dataSetName)

   return dataProducer



class ldr_viewer:
  def __init__(self, filename, ac_viewer=None, idv=None, metadata=None):

    self.longitudeName   = metadata['longitudeName']
    self.latitudeName    = metadata['latitudeName']
    self.profileTimeName = metadata['profileTimeName']
    self.sfcElevName     = metadata['sfcElevName']
    self.dataRange       = metadata['dataRange']
    self.colorTable      = metadata['colorTable']
    self.dataSetName     = metadata['datasetName']

    self.subsetRef = []
    self.subsetRef.append(None)

    self.hrImageRef   = DataReferenceImpl("hres image")
    self.hr3DImageRef = DataReferenceImpl("3D image")
    self.hr3DMeshRef  = DataReferenceImpl("mesh 3D")

    track_display = None
    self.threeD   = false

    if ac_viewer != None:
      track_display = ac_viewer.d

    if idv != None:
      self.threeD = true
      
    reader = HDF4File(filename)

    trackLen = reader.getNumObsLines(metadata['trackDimName'])
    vertLen  = reader.getNumObsLines(metadata['vertDimName'])

    track_skip = metadata['track_skip']
    vert_skip = metadata['vert_skip']
    track_start = metadata['track_start']
    self.track_skipHR = metadata['track_skipHR']

    start  = [track_start,0]
    stride = [track_skip,1]
    count  = [trackLen/track_skip, 1]

    lonValues  = reader.getValues(self.longitudeName, start, count, stride)
    latValues  = reader.getValues(self.latitudeName, start, count, stride)
    timeValues = reader.getValues(self.profileTimeName, start, count, stride)

    sfcValues = None
    if self.sfcElevName != None:
      sfcValues  = reader.getValues(self.sfcElevName, start, count, stride)


    time0 = timeValues[0]
    start_time = time0
    timeN = timeValues[len(timeValues)-1]

    start_stop = getStartStopTime(metadata['instrumentName'], reader, [start_time, timeN])
    start_time = start_stop[0]
    timeN = start_stop[1]


    inc = (timeN - start_time)/count[0]
    time0 = 0
    timeValues = []
    for i in xrange(count[0]):
      timeValues.append(float(time0 + i*inc))

    timeValues_all = []
    inc = (timeN-start_time)/trackLen
    for i in xrange(trackLen):
      timeValues_all.append(float(time0 + i*inc))
   

    self.time_inc  = inc
    self.lonValues = lonValues
    self.latValues = latValues


    altValues = metadata['altValuesLR']
    self.altValues_all = metadata['altValuesHR']
    vertLen = len(self.altValues_all)

    time_minmax = Helper.minmax(timeValues)
    alt_minmax = Helper.minmax(self.altValues_all)

    t_index = (len(timeValues))/3
    y_range = [0, alt_minmax[1]]
    x_init  = timeValues[t_index]

    timeLen  = trackLen/track_skip
    rangeLen = vertLen/vert_skip

    unit = Parser.parse("seconds since 1993-01-01 00:00:00Z")
    unit = OffsetUnit(start_time, unit)
    timeType = RealType.getRealType("Track_Time", unit, None)
    self.timeType = timeType



    #-- everything below here should be general enough
    domain_2D = RealTupleType(altType, timeType)
    self.domain_3D = RealTupleType(RealType.Altitude, RealType.Longitude, RealType.Latitude)

    #- 2D  plot
    rVals = jarray.zeros(timeLen*rangeLen, 'f')
    tVals = jarray.zeros(timeLen*rangeLen, 'f')

    cnt = 0
    for i in xrange(timeLen):
      for j in xrange(rangeLen):
        rVals[cnt] = altValues[j]
        tVals[cnt] = timeValues[i]
        cnt += 1

    set_2D = Gridded2DSet(domain_2D, [rVals, tVals], rangeLen, timeLen)
    self.timeSet = Gridded1DSet(timeType, [timeValues], timeLen)

    self.subsetDomain_x = Gridded1DSet(altType, [self.altValues_all], vertLen)
    self.subsetDomain_y = Gridded1DSet(timeType, [timeValues_all], trackLen)

    start  = [track_start,0]
    stride = [track_skip, vert_skip]
    count  = [trackLen/track_skip, vertLen/vert_skip]

    clr_table = self.colorTable

    dataProducer = getDataProducer(reader, self.dataSetName)

    tabDisp = CurtainDisplay2D(set_2D, self.dataSetName, DataCoords(start, stride, count), clr_table, timeType, time_minmax, x_init, altType, y_range, tabType, self.dataRange, reader, dataProducer)

    if sfcValues != None:
      sfcElev = Gridded2DDoubleSet(domain_2D, [(Set.floatToDouble([sfcValues]))[0], timeValues], timeLen)
      tabDisp.addData("sfc", sfcElev)

    self.all_displays = []
    self.all_displays.append(tabDisp)

    display2D = tabDisp.getDisplay()
    xmap = tabDisp.getXmap()
    ymap = tabDisp.getYmap()

    from hframe import HFrame
    #frame     = JFrame(self.dataSetName, windowClosing=self.windowClosing)
    frame     = HFrame(self.dataSetName, windowClosing=self.windowClosing)
    framePane = frame.getContentPane()
    framePane.setLayout(BorderLayout())

    selectRef = display2D.addData("left", Real(timeType, x_init),
      constantMaps=[ConstantMap(-0.5, Display.YAxis)]+makeColorMap("cyan"), renderer=OneDProbeRendererJ3D(self.timeSet))
    self.selectRef = selectRef

    si = SubsetImage(tabDisp.getImage(),display2D,ymap,xmap,self.changeSubset,self.subsetRef,color="white")
    self.subsetRef[0].setKeepLastBoxOn(false)

    from DisplayViewSelect import DisplayViewSelectToolBar, RubberBandSubset
    toolbar = DisplayViewSelectToolBar([display2D], [1], pickAction="grab")
    toolbar.addHAction(RubberBandSubset(toolbar.listeners, self.subsetRef, icon=hydra_path+"/ui/icons/subset16.jpg", tooltipText="Subset Image"))

    framePane.add("Center", display2D.getComponent())
    framePane.add("South", toolbar)
    
    colorBar = ColorBarWidget(tabDisp.getRGBMap())
    framePane.add("North", colorBar)

    #- menuBar
    menuBar     = JMenuBar()
    toolMenu    = JMenu("Tools")
    menuBar.add(toolMenu)
    item1 = JMenuItem("Capture Display", actionPerformed=self.captureDisplay)
    item1.setEnabled(1)
    toolMenu.add(item1)
    frame.setJMenuBar(menuBar)

    frame.pack()
    frame.setSize(600, 400)
    frame.show()


    self.trackRef = DataReferenceImpl("track_pt")
    self.trackPointRef3D = DataReferenceImpl("track point")
    self.trackRef.setData(None)
    self.display2D = display2D
    self.domain_2D = domain_2D
    self.tabType = tabType
    self.reader = reader
    self.frame = frame

    self.tabDisp = tabDisp

    if idv == None:
      pass
    else:
      self.hrImageRef.setData(tabDisp.getImage())
      idv.load(None, self.hrImageRef, None, 'lidar', 'hydra.lidar')

    tabDisp.setTimeProbe(selectRef, self.callback)

    self.y_range = y_range
    self.x_init = x_init

#--- depolarization 
    """
    dataProducer = DerivedDataProducer([totalBackscatter,  DataProducer(DataRetriever(reader), 'Perpendicular_Attenuated_Backscatter_532')], 'depolarization', depolarization)

    clr_fnc = makeDepolarizationColorFunction()
    tabDisp2 = CurtainDisplay2D(set_2D, 'depolarization', DataCoords(start, stride, count), clr_fnc, timeType, time_minmax, x_init, altType, y_range, depolarType, [0.02, 0.7], reader, dataProducer)

    self.all_displays.append(tabDisp2)

    from hframe import HFrame
    #frame     = JFrame("Depolarization_532")
    frame     = HFrame("Depolarization_532")
    framePane = frame.getContentPane()
    framePane.setLayout(BorderLayout())

    framePane.add("Center", tabDisp2.getDisplay().getComponent())

    from DisplayViewSelect import DisplayViewSelectToolBar
    toolbar = DisplayViewSelectToolBar([tabDisp2.getDisplay()], [1])
    framePane.add("South", toolbar)

    frame.pack()
    frame.setSize(600, 400)
    frame.show()

    tabDisp2.setTimeProbe(selectRef, None)
    """

#-- track plot -------

    set_2D = Gridded2DDoubleSet(RealTupleType.SpatialEarth2DTuple, [lonValues, latValues], timeLen)
    if track_display != None:
      self.trackPath = track_display.addData("track", set_2D, makeColorMap("green"))
      track_display.addReference(self.trackRef, makeColorMap("magenta"))

    self.track_display = track_display

  def update3DMesh(self, lonValues, latValues, timeLen, altLevels):
    gset_s = []
    n_alts = len(altLevels)
    for i in xrange(len(altLevels)):
                                                                                                                              
      alts = jarray.zeros(timeLen, 'f')
      for j in xrange(timeLen):
        alts[j] = altLevels[i]
      lon_lat_alt = [lonValues, latValues, alts]
                                                                                                                              
      gset = Gridded3DSet(RealTupleType.SpatialEarth3DTuple, lon_lat_alt, timeLen)
      gset_s.append(gset)
                                                                                                                              
    lons = jarray.zeros(len(altLevels), 'f')
    lats = jarray.zeros(len(altLevels), 'f')
    alts = jarray.zeros(len(altLevels), 'f')
                                                                                                                              
    for i in xrange(len(altLevels)):
      lons[i] = lonValues[0]
      lats[i] = latValues[0]
      alts[i] = altLevels[i]
                                                                                                                              
    gset = Gridded3DSet(RealTupleType.SpatialEarth3DTuple, [lons, lats, alts], n_alts)
    gset_s.append(gset)
                                                                                                                              
    for i in xrange(len(altLevels)):
      lons[i] = lonValues[timeLen-1]
      lats[i] = latValues[timeLen-1]
      alts[i] = altLevels[i]
                                                                                                                              
    gset = Gridded3DSet(RealTupleType.SpatialEarth3DTuple, [lons, lats, alts], n_alts)
    gset_s.append(gset)
                                                                                                                              
    uset = UnionSet(gset_s)
                                                                                                                              
    label = Tuple(TupleType([RealType.Longitude, RealType.Latitude, RealType.Altitude, TextType.Generic]), [Real(RealType.Longitude, lonValues[0]), Real(RealType.Latitude, latValues[0]), Real(RealType.Altitude, 1000.0), Text(TextType.Generic, '   %-6.2f' % 1000.0)])
    self.hr3DMeshRef.setData(Tuple([uset, label]))



  def makeColorTable(self):
    red_c=[0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,42.5,85.0,127.5,170.0,212.5,255.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,42.5,85.0,127.5,170.0,212.5,255.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,42.5,85.0,127.5,170.0,212.5,255.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,42.5,85.0,127.5,170.0,212.5,255.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,42.5,85.0,127.5,170.0,212.5,255.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,42.5,85.0,127.5,170.0,212.5,255.0,
           0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,255.0,255.0,255.0,255.0,255.0,
           0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,255.0,255.0,255.0,255.0,255.0,
           0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,255.0,255.0,255.0,255.0,255.0,
           0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,255.0,255.0,255.0,255.0,255.0,
           0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,255.0,255.0,255.0,255.0,255.0,
           0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,255.0,255.0,255.0,255.0,255.0,255.0,
           42.5,85.0,127.5,170.0,212.5,42.5,85.0,127.5,170.0,212.5,
           42.5,85.0,127.5,170.0,212.5,42.5,85.0,127.5,170.0,212.5,42.5,85.0,127.5,170.0,212.5]

    green_c=[0.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,
             255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,
             255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,
             255.0,255.0,255.0,255.0,255.0,255.0,255.0,212.5,212.5,212.5,212.5,212.5,212.5,212.5,
             170.0,170.0,170.0,170.0,170.0,170.0,170.0,127.5,127.5,127.5,127.5,127.5,127.5,127.5,
             85.0,85.0,85.0,85.0,85.0,85.0,85.0,42.5,42.5,42.5,42.5,42.5,42.5,42.5,
             0.0,0.0,0.0,0.0,0.0,0.0,0.0,
             212.5,170.0,127.5,85.0,42.5,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,
             212.5,170.0,127.5,85.0,42.5,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,
             212.5,170.0,127.5,85.0,42.5,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,
             212.5,170.0,127.5,85.0,42.5,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,
             212.5,170.0,127.5,85.0,42.5,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,
             212.5,170.0,127.5,85.0,42.5,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,85.0,127.5,170.0,212.5,
             42.5,42.5,42.5,42.5,42.5,85.0,85.0,85.0,85.0,85.0,
             127.5,127.5,127.5,127.5,127.5,170.0,170.0,170.0,170.0,170.0,212.5,212.5,212.5,212.5,212.5]

    blue_c=[0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,42.5,42.5,42.5,42.5,42.5,42.5,42.5,
            85.0,85.0,85.0,85.0,85.0,85.0,85.0,127.5,127.5,127.5,127.5,127.5,127.5,127.5,
            170.0,170.0,170.0,170.0,170.0,170.0,170.0,212.5,212.5,212.5,212.5,212.5,212.5,212.5,
            255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,
            255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,
            255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,255.0,
            255.0,255.0,255.0,255.0,255.0,255.0,255.0,
            212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,212.5,
            170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,170.0,
            127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,127.5,
            85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,85.0,
            42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,42.5,
            0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
            0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
            0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]

    g_scale = [70,100,130,155,180,200,225,235,240,242,245,249,253]

    for i in xrange(len(red_c)):
      red_c[i] /= 255.0
      green_c[i] /= 255.0
      blue_c[i] /= 255.0

    for j in xrange(len(g_scale)):
      red_c[10+j] = g_scale[j]/255.0
      green_c[10+j] = g_scale[j]/255.0
      blue_c[10+j] = g_scale[j]/255.0


    indexes = []
    ff = open(hydra_path+'/ancillary/lidar/Colors_532.txt')
    lines = ff.readlines()
    nlines = len(lines)
    for i in xrange(nlines):
      fields = lines[i].split()
      indexes.append(int(fields[0]))

    red   = []
    green = []
    blue  = []

    for i in xrange(nlines):
      red.append(red_c[indexes[i]])
      green.append(green_c[indexes[i]])
      blue.append(blue_c[indexes[i]])

    return [red, green, blue]


  def callback(self,val):
    idx = (self.timeSet.doubleToIndex([[val]]))[0]
    self.trackRef.setData(RealTuple(RealTupleType.SpatialEarth2DTuple, [self.lonValues[idx], self.latValues[idx]]))
    """
    for i in xrange(len(self.altValues)-3):
      self.lons[i] = self.lonValues[idx]
      self.lats[i] = self.latValues[idx]
      self.alts[i] = self.altValues[i]*1000.0
    self.trackPointRef3D.setData(Gridded3DDoubleSet(RealTupleType.SpatialEarth3DTuple, [self.lons, self.lats, self.alts], len(self.altValues)-3))
    """


  def windowClosing(self, event):
    if self.track_display != None:
      self.track_display.removeReference(self.trackRef)
      self.track_display.removeReference(self.trackPath)

  def captureDisplay(self,event):
    Helper.saveDisplay(self.display2D, JFrame().getContentPane())


  def changeSubset(self, a, b):
    self.frame.setCursor(3)
    f_coords = []
    f_coords.append((self.subsetDomain_x.valueToGrid([a]))[0])
    f_coords.append((self.subsetDomain_y.valueToGrid([b]))[0])

    x0 = min(f_coords[0])
    x1 = max(f_coords[0])
    y0 = min(f_coords[1])
    y1 = max(f_coords[1])

    skip = self.track_skipHR

    rangeLen = int((x1-x0)+1)
    timeLen  = int((y1-y0)+1)/skip

    if (rangeLen < skip or timeLen < skip):
      self.frame.setCursor(0)
      return

    altValues = self.altValues_all[int(x0):(int(x0)+rangeLen)]

    start  = [y0,x0]
    stride = [skip, 1]
    count  = [timeLen, rangeLen]

    dataCoords = DataCoords(start, stride, count)

    start  = [y0,0]
    stride = [skip,1]
    count  = [timeLen, 1]

    field = None
    timeValues = []
    for i in xrange(count[0]):
      timeValues.append(float(start[0]*self.time_inc + i*stride[0]*self.time_inc))

    if (self.threeD == false):
      rVals = jarray.zeros(timeLen*rangeLen, 'd')
      tVals = jarray.zeros(timeLen*rangeLen, 'd')
      r_x_t = [rVals, tVals]
      Helper.oneD_twoDfill(altValues, rangeLen, timeValues, timeLen, r_x_t)

      set_2D = Gridded2DDoubleSet(self.domain_2D, r_x_t, rangeLen, timeLen)
      self.updateBox(Linear2DSet(self.domain_2D, altValues[0], altValues[rangeLen-1], rangeLen, timeValues[0], timeValues[timeLen-1], timeLen))
      self.update(set_2D, dataCoords)
      self.selectRef.setData(Real(self.timeType, timeValues[0]))
    else:
      lonValues  = self.reader.getValues(self.longitudeName, start, count, stride)
      latValues  = self.reader.getValues(self.latitudeName, start, count, stride)

      vals0 = jarray.zeros(timeLen*rangeLen, 'f')
      vals1 = jarray.zeros(timeLen*rangeLen, 'f')
      vals2 = jarray.zeros(timeLen*rangeLen, 'f')
      alt_lon_lat = [vals0, vals1, vals2]
      for i in xrange(len(altValues)):
        altValues[i] *= 1000.0
      Helper.oneD_threeDfill(lonValues, latValues, timeLen, altValues, rangeLen, alt_lon_lat)
                                                                                                                                   
      set_3D = Gridded3DSet(self.domain_3D, alt_lon_lat, rangeLen, timeLen)
      self.updateBox(Linear2DSet(self.domain_2D, altValues[0], altValues[rangeLen-1], rangeLen, float(start[0]*self.time_inc), float(start[0]*self.time_inc + (timeLen-1)*stride[0]*self.time_inc), timeLen))
      self.update(set_3D, dataCoords)
      self.selectRef.setData(Real(self.timeType, float(start[0]*self.time_inc)))


    if self.hrImageRef == None:
      self.hrImageRef = self.display2D.addData("tabhr", field)
    else:
      self.hrImageRef.setData(field)

    self.frame.setCursor(0)


  def get3DData(self):
    self.frame.setCursor(3)
    f_coords = []
    f_coords.append((self.subsetDomain_x.valueToGrid([a]))[0])
    f_coords.append((self.subsetDomain_y.valueToGrid([b]))[0])

    x0 = min(f_coords[0])
    x1 = max(f_coords[0])
    y0 = min(f_coords[1])
    y1 = max(f_coords[1])

    rangeLen = int((x1-x0)+1)
    timeLen  = int((y1-y0)+1)/4

    start  = [0,x0]
    stride = [1, 1]
    count  = [1, rangeLen]
    altValues = self.altValues_all[int(x0):(int(x0)+rangeLen)]

    start  = [y0,x0]
    stride = [4, 1]
    count  = [timeLen, rangeLen]
    tabValues = self.reader.getValues(self.dataSetName, start, count, stride)

    start  = [y0,0]
    stride = [4,1]
    count  = [timeLen, 1]

    lonValues  = reader.getValues(self.longitudeName, start, count, stride)
    latValues  = reader.getValues(self.latitudeName, start, count, stride)

    vals0 = jarray.zeros(timeLen*rangeLen, 'd')
    vals1 = jarray.zeros(timeLen*rangeLen, 'd')
    vals2 = jarray.zeros(timeLen*rangeLen, 'd')
    alt_lon_lat = [vals0, vals1, vals2]
    Helper.oneD_threeDfill(altValues, rangeLen, lonValues, latValues, timeLen, alt_lon_lat)

    set_3D = Gridded3DDoubleSet(self.domain_3D, alt_lon_lat, rangeLen, timeLen)
    field = FlatField(FunctionType(self.domain_3D, self.tabType), set_3D, None, None, [FloatSet(SetType(self.tabType))], None)
    field.setSamples([tabValues], false)

    return field


  def update(self, domainSet, dataCoords):
    for i in xrange(len(self.all_displays)):
      self.all_displays[i].update(domainSet, dataCoords)

  def updateBox(self, set):
    for i in xrange(len(self.all_displays)):
      self.all_displays[i].updateBox(set)


#---------------------------------------------------------------------------------------

from javax.swing import JFileChooser, JFrame

class LDR_GetData:
  def __init__(self, ac_viewer, idv, platform):
    self.ac_viewer = ac_viewer
    self.idv = idv
    self.platform = platform
    self.fileChoose = JFileChooser(actionPerformed=self.fileChooseAction)
    self.fileChoose.setDialogType(JFileChooser.OPEN_DIALOG)
    self.fileChoose.showOpenDialog(JFrame())

  def fileChooseAction(self, event):
    if event.getActionCommand() == "ApproveSelection":
      filename = self.fileChoose.getSelectedFile().getPath()
      table = fillMetadataTable(self.platform)
      ldr_viewer(filename, self.ac_viewer, self.idv, table)

def start(ac_viewer=None, idv=None, platform=None):
  LDR_GetData(ac_viewer, idv, platform)
