from visad import CellImpl
from hydra_properties import true, false
from util import ActionSync

# Application workaround for a synchronization problem
# with the hdf4 plug in (plug_hdf.exe).  There should 
# probably be a separate plug_in process for each file
# opened but since one plug_in per sessions works well
# on each platform, leave as is.

syn_object = ActionSync()

lockCell_dict = {}

#-----------------------------------------------------

class LockCell(CellImpl):
  def __init__(self, theRef, callback=None):
    CellImpl.__init__(self)
    self.theRef    = theRef
    self.callback  = callback
    self.init      = true
    self.noTrigger = false
    lockCell_dict.update({self : theRef})

  def doAction(self):
    if self.noTrigger == true:
      self.noTrigger = false
      return

    #- wait if another Action already passed through ActionSync
    if self.init != true:
      syn_object.waitHere()
      data = self.theRef.getData()
      if self.callback != None:
        self.callback(data)
      syn_object.finished()
    else:
      self.init = false

  def setNoTrigger(self, noTrigger):
    keys = lockCell_dict.keys()
    for i in xrange(len(lockCell_dict)):
      if lockCell_dict.get(keys[i]) == self.theRef:
        keys[i].noTrigger = noTrigger
