import visad
from visad.bom import RubberBandLineRendererJ3D
from visad import DataReferenceImpl, Gridded2DSet, RealTupleType, RealType, CellImpl, ConstantMap, Display
from visad import FunctionType, Data, FlatField, Integer1DSet, Tuple, Real, Text, RealTuple, Gridded1DSet
from visad import ScalarMap
import subs
from subs import makeColorMap
from javax.swing import JFrame, JMenuBar, JMenu, JMenuItem, JRadioButtonMenuItem, ButtonGroup, JCheckBoxMenuItem
from javax.swing import JPanel, JLabel, JButton, JToggleButton
import jarray
from util import Helper, MyRubberBandLineRendererJ3D, OneDProbeRendererJ3D, Syncher
from java.lang import Float, Math, Object, Thread
from java.awt import BorderLayout, GridLayout, FlowLayout, Color

import hydra_properties
from transectImage import TransectImage
from dragPointOnLine import DragablePointOnLine

false = 0
true  = 1


frame = None
transectDisp = None

enabled = false

refToImage_s = []
tcell_s = []
imgDisp_s = []
transectRef_s = []
acView_s = []
lineRenderer_s = []
tranFieldRef_s = []
probeRef_s = []

lineColor_s = ['magenta', 'blue', 'orange']

updateAll = true

cnt = 0

def clear():
  if tcell.lineRef != None:
    for i in xrange(len(refToImage_s)):
      tcell_s[i].removeReference(refToImage_s[i])
      imgDisp_s[i].removeReference(tcell_s[i].lineRef)
      tcell_s[i].dragPt1.remove()
      imgDisp_s[i].removeReference(transectRef_s[i])

def captureDisplay(event):
  Helper.saveDisplay(transectDisp, JFrame().getContentPane())

def windowClose(event):
  global frame, transectDisp, enabled, refToImage_s, tcell_s, imgDisp_s, transectRef_s
  global acView_s, lineRenderer_s, tranFieldRef_s, probeRef_s, cnt

  clear()
  for i in xrange(len(acView_s)):
    acView_s[i].finishTransect()
  transectDisp = None
  frame = None
  enabled = false
  refToImage_s = []
  tcell_s = []
  imgDisp_s = []
  transectRef_s = []
  acView_s = []
  lineRenderer_s
  tranFieldRef_s = []
  probeRef_s = []
  cnt = 0

def newTransect(event):
  for i in xrange(len(lineRenderer_s)):
    lineRenderer_s[i].active = true

def dragProbe(event):
  for i in xrange(len(lineRenderer_s)):
    lineRenderer_s[i].active = false

def toggleAutoScale(event):
  global transectDisp
  if event.getActionCommand() == 'on':
    print 'not implemented'
  
def toggleLast(event):
  global transectDisp, tranFieldRef_s, last2chkBox, southPanel, updateAll

  if last2chkBox.isSelected() == true:
    updateAll = true
  else:
    updateAll = false
  
def callback(x,y):
  print x,y
  
def makeTransectDisplay(filereader, image, imageRef, imageDisplay, roamTextRef, acViewer, lon_idx=0, lat_idx=1, dspAltLev=0.0, altitudeMap=None):
  global transectDisp, frame, img_disp, transectRef, tcell, ac_view, lineIdxRef, lineRenderer_s, enabled, tranFieldRef_s
  global last2chkBox, probeRef, maps, rangeType, southPanel, updateAll, cnt, probeRef_s
  
  obsElementInstrument, obsLineInstrument, obsChannelIndexInstrument, observationChannelsInstrument, observationsInstrument = filereader.getRealTypes()
  obsLatitudeInstrument, obsLongitudeInstrument = filereader.getGeoRealTypes()

  ac_view  = acViewer
  if len(acView_s) > 0:
    for i in xrange(len(acView_s)):
      if (ac_view == acView_s[i]):
        return
  acView_s.append(ac_view)

  img_disp = imageDisplay
  imgDisp_s.append(img_disp)
  refToImage_s.append(imageRef)
  
  distType = RealType.getRealType("dist,km")
  rangeType = imageRef.getData().getType().getRange()
  maps     = subs.makeMaps(distType, 'x', rangeType, 'y')

  if transectDisp == None:
    transectDisp = subs.makeDisplay(maps)

    mode = transectDisp.getGraphicsModeControl()
    mode.setPointSize(5)
    dsp_rdr = transectDisp.getDisplayRenderer()
    dsp_rdr.setBackgroundColor(hydra_properties.background_color)
    dsp_rdr.setForegroundColor(hydra_properties.foreground_color)
    subs.setAspectRatio(transectDisp, 2)
    subs.setBoxSize(transectDisp, .7)
    transectDisp.showAxesScales(true)
    transectDisp.setAlwaysAutoScale(true)
    as = maps[1].getAxisScale()
    as.setSide(0)
    as.setVisible(1)

    transectDisp.disableAction()
    for i in xrange(len(lineColor_s)):
      tranFieldRef = DataReferenceImpl("tranFieldRef")
      tranFieldRef.setData(Real(RealType.Generic, Float.NaN))
      tranFieldRef_s.append(tranFieldRef)
      lineColor = lineColor_s[i]
      transectDisp.addReference(tranFieldRef, subs.makeColorMap(lineColor))
      probeRef         = DataReferenceImpl("probeRef")
      probeRef.setData(Real(distType, Float.NaN))
      probeRef_s.append(probeRef)
      transectDisp.addReferences(OneDProbeRendererJ3D(), probeRef, [ConstantMap(-0.5, Display.YAxis)]+makeColorMap('green'))
    transectDisp.enableAction()
      

  transectRef = DataReferenceImpl("transectRef")
  transectRef_s.append(transectRef)
  obsLatitudeInstrument, obsLongitudeInstrument = filereader.getGeoRealTypes()

  if len(transectRef_s) > 1:
    transectRef.setData(transectRef_s[0].getData())
  else:
    transectRef.setData(Gridded2DSet(RealTupleType(RealType.XAxis,RealType.YAxis), None, 1))

  lineColor = lineColor_s[cnt]

  lineRenderer = MyRubberBandLineRendererJ3D(RealType.XAxis,RealType.YAxis,0,0)
  lineRenderer_s.append(lineRenderer)
  imageDisplay.addReferences(lineRenderer, transectRef, subs.makeColorMap(lineColor)+[ConstantMap(dspAltLev, Display.ZAxis)])

  lineIdxRef       = DataReferenceImpl("lineIdxRef:transect")
  local_lineIdxRef = DataReferenceImpl("lineIdxRef:transect")
  trackPtRef       = DataReferenceImpl("track point")

  probeRef = probeRef_s[cnt]
  tranFieldRef = tranFieldRef_s[cnt]

  tranDomainSetRef = DataReferenceImpl("tranDomianSetRef")

  lineRef = None
  enabled = true
  cnt += 1

  class IndexChangeCell(CellImpl):
    def __init__(self, lineIdxRef, tranDomainSetRef, distType, probeRef):
      self.lineIdxRef = lineIdxRef
      self.tranDomainSetRef = tranDomainSetRef
      self.distType = distType
      self.lockOut = 0
      self.probeRef = probeRef
      self.first = 0
      self.probeChangeCell = None

    def lock(self):
      self.lockOut = 1

    def unlock(self):
      self.lockOut = 0

    def doAction(self):
      if self.first == 0:
        self.first = 1
        return

      if self.lockOut == 0:
        self.idx = int(self.lineIdxRef.getData().getValue())
        self.probeChangeCell.lock()
        self.probeRef.setData(Real(self.distType, (self.tranDomainSetRef.getData().indexToValue([self.idx]))[0][0]))
      else:
        self.lockOut = 0

  idxChangeCell = IndexChangeCell(lineIdxRef, tranDomainSetRef, distType, probeRef)
  idxChangeCell.addReference(lineIdxRef)

  class ProbeChangeCell(CellImpl):
    def __init__(self, lineIdxRef, probeRef, tranDomainSetRef, idxChangeCell):
      self.lineIdxRef = lineIdxRef
      self.probeRef = probeRef
      self.tranDomainSetRef = tranDomainSetRef
      self.idxChangeCell = idxChangeCell
      self.first   = 0
      self.lockOut = 0

    def lock(self):
      self.lockOut = 1

    def doAction(self):
      if self.first == 0:
        self.first = 1
        return

      if self.lockOut == 0:
        val = self.probeRef.getData().getValue()
        idx = (self.tranDomainSetRef.getData().valueToIndex([[val]]))[0]
        self.idxChangeCell.lock()
        self.lineIdxRef.setData(Real(RealType.Generic, float(idx)))
      else:
        self.lockOut = 0

  probeChangeCell = ProbeChangeCell(local_lineIdxRef, probeRef, tranDomainSetRef, idxChangeCell)
  probeChangeCell.addReference(probeRef)
  idxChangeCell.probeChangeCell = probeChangeCell

  
  class TransectChangeCell(CellImpl):
    def __init__(self, transectDisp, transectRef, lineRef, image, imageRef, imageDisplay, roamTextRef, ac_view, lineIdxRef, local_lineIdxRef, tranDomainSetRef, tranFieldRef, tran_ymap, lineColor, syncher, lon_idx=0, lat_idx=1, dspAltLev=0.0, altitudeMap=None):
      self.transectRef  = transectRef
      self.lineRef      = lineRef
      self.image        = image
      self.imageDisplay = imageDisplay
      self.transectDisp = transectDisp
      self.roamTextRef  = roamTextRef
      self.ds_cs        = ac_view.ds_cs
      self.ac_view      = ac_view
      self.imageRef     = imageRef
      self.last_image   = None
      self.last_samples = None
      self.displayAltType = ac_view.displayAltType
      self.lineIdxRef   = lineIdxRef
      self.tranDomainSetRef = tranDomainSetRef
      self.dragPt1 = None
      self.local_lineIdxRef = local_lineIdxRef
      self.tranFieldRef = tranFieldRef
      self.init = false
      self.override = false
      self.lon_idx = lon_idx
      self.lat_idx = lat_idx
      self.dspAltLev = dspAltLev
      self.altitudeMap = altitudeMap
      self.tran_ymap = tran_ymap
      self.lineColor = lineColor
      self.syncher = syncher
      self.updateAll_lock = false
  
    def setDisplayCS(self, cs):
      self.ds_cs = cs

    def setDisplayAltType(self, type):
      self.displayAltType = type

    def setImageRef(self, imgRef):
      self.imageRef = imgRef

    def setRGBmap(self, map):
      pass
      
    def update(self, override=false):
      self.override = override
      self.doAction()
      self.override = false
                
    def doAction(self):
      if self.init == false:
        self.init = true
        self.syncher.finished()
        return

      self.ac_view.frame.setCursor(3)
      doit = true
      samples = self.transectRef.getData().getSamples()
      image = self.imageRef.getData()


      if samples != None:
        if (self.last_samples == samples):
          if (self.last_image == image):
            doit = false
        self.last_samples = samples
        self.last_image   = image
        
        #- need flatfield with navigation here
        if image.getType().getDomain().getCoordinateSystem() == None:
          image = self.ac_view.getNavigatedImage(replace=false)

        if (doit == true or self.override == true):
          save_pts = [[],[]]
          del_x = samples[0][1] - samples[0][0]
          del_y = samples[1][1] - samples[1][0]
          line_vec  = [del_x, del_y]
          line_len  = Math.sqrt(del_x*del_x + del_y*del_y)
          if visad.util.Util.isApproximatelyEqual(line_len, 0.0) == 1:
            self.ac_view.frame.setCursor(0)
            return
          line_uvec = [del_x/line_len, del_y/line_len]
          samp = [samples[0][0], samples[1][0]]
          ll_pts = self.ds_cs.fromReference([[samp[0]],[samp[1]],[0]])
          lat = ll_pts[self.lat_idx][0]
          lon = ll_pts[self.lon_idx][0]
          xy = self.ac_view.ad.cs.fromReference([[lat],[lon]])
          x = float(xy[0][0])
          y = float(xy[1][0])
          dset = image.getDomainSet()
          lens = dset.getLengths()
          dim = len(lens)
          idx  = dset.valueToIndex([[x], [y]])
          gg = []
          k  = idx[0]
          for j in xrange(dim-1):
            gg.append(k % lens[j])
            k = k / lens[j]
          gg.append(k)
          grid = []
          for j in xrange(len(gg)):
            grid.append([float(gg[j])])
      
          grid_loc = self.ac_view.ad.cs.toReference(dset.indexToValue(idx))
          grid_loc = self.ds_cs.toReference([[grid_loc[self.lat_idx][0]], [grid_loc[self.lon_idx][0]], [0]])
        
          #- get mark point along line
          samp_to_grid = [grid_loc[0][0]-samp[0], grid_loc[1][0]-samp[1]]
          dot = samp_to_grid[0]*line_uvec[0] + samp_to_grid[1]*line_uvec[1]
          line_mark = [(dot*line_uvec[0])+samp[0], (dot*line_uvec[1])+samp[1]]
          save_pts[0].append(line_mark)
          save_pts[1].append(grid)

          past_last = false
          while (past_last == false):
            udot_max = Float.MIN_VALUE
            grid_dot_max = None
            for j in [-1,0,1]:
              for i in [-1,0,1]:
                test_grid = [[grid[0][0]+i], [grid[1][0]+j]]
                grid_loc = self.ac_view.ad.cs.toReference(dset.gridToValue(test_grid))
                grid_loc = self.ds_cs.toReference([[grid_loc[self.lat_idx][0]], [grid_loc[self.lon_idx][0]], [0]])
                del_x = grid_loc[0][0] - line_mark[0]
                del_y = grid_loc[1][0] - line_mark[1]
                dst = Math.sqrt(del_x*del_x + del_y*del_y)
                test_uvec = [del_x/dst, del_y/dst]
                mark_uvec = [line_uvec[0], line_uvec[1]]
                udot = test_uvec[0]*mark_uvec[0] + test_uvec[1]*mark_uvec[1]
                if udot > udot_max:
                  udot_max = udot
                  dot = del_x*line_uvec[0] + del_y*line_uvec[1]
                  grid_dot_max = test_grid
            grid = grid_dot_max
            line_mark = [(dot*line_uvec[0])+line_mark[0], (dot*line_uvec[1])+line_mark[1]]
            save_pts[0].append(line_mark)
            save_pts[1].append(grid)
            del_x = line_mark[0]-samp[0]
            del_y = line_mark[1]-samp[1]
            dist = Math.sqrt(del_x*del_x + del_y*del_y)
            if dist >= line_len:
              past_last = true

          rtup_s = []
          lons = []
          lats = []
          for i in xrange(len(save_pts[0])):
            x = save_pts[0][i][0]
            y = save_pts[0][i][1]
            ll = self.ds_cs.fromReference([[x],[y],[0]])
            lons.append(ll[self.lon_idx][0])
            lats.append(ll[self.lat_idx][0])

          dist = []
          dist2 = []
          sum = 0
          sum2 = 0
          dist.append(sum)
          dist2.append(sum2)
          for i in xrange(len(lons)-1):
            lat2 = lats[i+1]*Data.DEGREES_TO_RADIANS
            lat1 = lats[i]*Data.DEGREES_TO_RADIANS
            del_lat = (lats[i+1]-lats[i])*Data.DEGREES_TO_RADIANS
            del_lon = (lons[i+1]-lons[i])*Data.DEGREES_TO_RADIANS
            #- cartesian approx
            ds = 6380*Math.sqrt(del_lat*del_lat + Math.cos(lat1)*Math.cos(lat1)*del_lon*del_lon)
            sum += ds
            dist.append(sum)
            #- from haversine formula
            """
            ds = 2*6380*Math.asin(Math.sqrt(Math.sin(del_lat/2)*Math.sin(del_lat/2)+Math.cos(lat1)*Math.cos(lat2)*Math.sin(del_lon/2)*Math.sin(del_lon/2)))
            sum2 += ds
            dist2.append(sum2)
            """

          n_pts = len(lats)
          self.gset = Gridded2DSet(RealTupleType(RealType.Latitude, RealType.Longitude), [lats, lons], n_pts)
          self.tranDomainSet = Gridded1DSet(RealType.Generic,[dist], n_pts)
          self.tranDomainSetRef.setData(self.tranDomainSet)
          self.lineIdxRef.setData(Real(RealType.Generic, n_pts/2))
       

          if self.dragPt1 == None:
            self.dragPt1 = DragablePointOnLine(DataReferenceImpl("track point"), self.lineIdxRef, self.gset, self.imageDisplay, self.ds_cs, self.displayAltType, self.lon_idx, self.lat_idx, self.dspAltLev, self.altitudeMap)
            self.dragPt1.setRemoteLineIdxRef(self.local_lineIdxRef)
          else:
            self.dragPt1.update(self.gset, self.ds_cs, self.displayAltType)
            self.local_lineIdxRef.setData(Real(RealType.Generic, n_pts/2))

          if self.lineRef == None:
            ##self.lineRef  = self.imageDisplay.drawLine(samples, color="magenta", width=2)
            self.lineRef  = subs.drawLineOnDisplayImpl(self.imageDisplay, samples, color=self.lineColor, mathtype=[RealType.XAxis, RealType.YAxis], width=2, zlayer=self.dspAltLev)
          else:
            ##self.imageDisplay.moveLine(self.lineRef, samples)
            subs.moveLine(self.lineRef, samples)
         

        tranField = image.resample(self.gset, Data.NEAREST_NEIGHBOR, Data.NO_ERRORS)
        values = tranField.getFloats()
        new_tranField = FlatField(FunctionType(RealType.getRealType("dist,km"), tranField.getType().getRange()), self.tranDomainSet)
        new_tranField.setSamples(values, false)

        self.tranFieldRef.setData(new_tranField)
     

        if self.roamTextRef != None:
          ttype = self.roamTextRef.getData().getType()
          comps =  ttype.getComponents()
          self.roamTextRef.setData(Tuple(ttype, [Real(comps[0], Float.NaN), Real(comps[1], Float.NaN), Text(comps[2], '   %-6.1f' % Float.NaN)]))
        
      self.ac_view.frame.setCursor(0)

      #--- new
      if (updateAll == true and self.updateAll_lock == false):
        idx = tcell_s.index(self)
        for i in xrange(len(tcell_s)):
          if i != idx and self.override == false:
            tcell_s[i].updateAll_lock = true
        for i in xrange(len(transectRef_s)):
          if (self.transectRef != transectRef_s[i]): #- don't do on self
            if (self.transectRef.getData() != transectRef_s[i].getData()):
              transectRef_s[i].setData(self.transectRef.getData())

      self.updateAll_lock = false

        
        
  syncher = Syncher()
  tcell = TransectChangeCell(transectDisp, transectRef, lineRef, image, imageRef, imageDisplay, roamTextRef, ac_view, lineIdxRef, local_lineIdxRef, tranDomainSetRef, tranFieldRef, maps[1], lineColor, syncher, lon_idx, lat_idx, dspAltLev, altitudeMap)

  syncher.init()
  tcell.addReference(transectRef)
  syncher.waitHere()
  Thread.sleep(100)

  tcell.init = false
  syncher.init()
  tcell.addReference(imageRef)
  syncher.waitHere()
  Thread.sleep(100)
  
  tcell_s.append(tcell)

  if len(tcell_s) > 1:
    Thread.sleep(1000)
    tcell.update(override=true)


  if frame == None:
    frame     = JFrame("Transect:   shft+rght+drag", windowClosing=windowClose)
    framePane = frame.getContentPane()
    framePane.setLayout(BorderLayout())

    #- menuBar
    menuBar = JMenuBar()
    toolMenu = JMenu("Tools")
    menuBar.add(toolMenu)
    toolItem1 = JMenuItem("Capture Display", actionPerformed=captureDisplay)
    toolItem1.setEnabled(1)
    toolMenu.add(toolItem1)
    menu = JMenu("Display")
    item1 = JRadioButtonMenuItem("new transect", actionPerformed=newTransect)
    item1.setEnabled(1)
    item1.setSelected(1)
    menu.add(item1)
    item2 = JRadioButtonMenuItem("drag probe", actionPerformed=dragProbe)
    item2.setEnabled(1)
    bg = ButtonGroup()
    bg.add(item1)
    bg.add(item2)
    menu.add(item2)
    toolMenu.add(menu)

    settingsMenu = JMenu("Settings")
    item1 = JCheckBoxMenuItem("update all", actionPerformed=toggleLast)
    item1.setEnabled(1)
    item1.setSelected(1)
    settingsMenu.add(item1)
    last2chkBox = item1
    frame.setJMenuBar(menuBar)
    item2 = JCheckBoxMenuItem("y-range <-> image-range", actionPerformed=toggleAutoScale)
    item2.setEnabled(0)
    item2.setSelected(0)
    settingsMenu.add(item2)
    menuBar.add(settingsMenu)
  
    framePane.add(transectDisp.getComponent(), BorderLayout.CENTER)
    from DisplayViewSelect import DisplayViewSelectToolBar
    southPanel = JPanel()
    southPanel.setLayout(GridLayout(0,2))
    southPanel.add(DisplayViewSelectToolBar([transectDisp], [1], pickAction="grab"))

    framePane.add(southPanel, BorderLayout.SOUTH)
  
    frame.pack()
    frame.show()
    frame.setSize(400,250)


def updateParameter(refToImage):
  global transectDisp, maps, rangeType, probeRef, enabled, last2chkBox

  if enabled == false:
    return

  transectDisp.removeAllReferences()
  transectDisp.removeMap(maps[1])
  rangeType = refToImage.getData().getType().getRange()
  maps[1] = ScalarMap(rangeType, Display.YAxis)
  transectDisp.addMap(maps[1])

  sm = maps[1]
  sm.setScaleEnable(true)
  sm.setScaleColor([0,0,0])

  transectDisp.addReferences(OneDProbeRendererJ3D(), probeRef, [ConstantMap(-0.5, Display.YAxis)]+makeColorMap('green'))
  transectDisp.addReference(tranFieldRef_s[0], subs.makeColorMap(hydra_properties.foreground_color))
  tranFieldRef_s[1].setData(Real(RealType.Generic, Float.NaN))
  tranFieldRef_s[2].setData(Real(RealType.Generic, Float.NaN))
  if last2chkBox.isSelected() == true:
    transectDisp.addReference(tranFieldRef_s[1], subs.makeColorMap('green'))
    transectDisp.addReference(tranFieldRef_s[2], subs.makeColorMap('red'))

  tcell.init = false
  tcell.setImageRef(refToImage)
  tcell.addReference(refToImage)
  tcell.update(true)
  refToImage_s.append(refToImage)


def updateImageRef(refToImage, ds_cs=None, altType=None):
  global enabled
  if enabled == false:
    return

  tcell.init = false
  if ds_cs != None and altType != None:
    tcell.setDisplayCS(ds_cs)
    tcell.setDisplayAltType(altType)

  tcell.setImageRef(refToImage)
  tcell.addReference(refToImage)
  tcell.update(true)
  refToImage_s.append(refToImage)

def update(refToImage):
  global enabled
  if enabled == false:
    return
  tcell.init = false
  tcell.addReference(refToImage)
  tcell.update(true)
  refToImage_s.append(refToImage)
